#!/usr/bin/perl
# $Id: crawler.pl 4097 2008-04-30 18:08:30Z pro $ $URL: svn://svn.setun.net/search/trunk/crawler.pl $

=copyright
PRO-search crawler
Copyright (C) 2003-2007 Oleg Alexeenkov http://pro.setun.net/search/ proler@gmail.com icq#89088275

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA,
or download it from http://www.gnu.org/licenses/gpl.html
=cut

package pscrawler;
use Time::Local;
eval { use Time::HiRes qw(time sleep); };
use Net::FTP;
use strict;
use Data::Dumper;    #dev only
$Data::Dumper::Sortkeys = 1;
no warnings qw(uninitialized);
exit if defined $ENV{'REMOTE_ADDR'};    # cgi not allowed
#use lib './dcppp', './lib';
our ( %config, $param, %work, %stat, %static );
our ( %processor, %program );           #, %human
#=z
#use vars
my ( $tq, $rq, $vq );
our ( @ISA, @EXPORT, @EXPORT_OK );
require Exporter;
@ISA    = qw(Exporter);
@EXPORT = qw( %config $param %work %stat %static );
#=cut
$0 =~ m|^(.+)[/\\].+?$|;                #v0
our $root_path = $1 . '/' if $1;
$root_path =~ s|\\|/|g;
eval "use lib '$root_path'" if $root_path;
eval "use lib '$root_path./dcppp', '$root_path./lib';
      use dcppp::clihub; use psmisc; use pssql;";
print($@), exit if $@;
#use lib ;
my (%ipstt);
#our was here
$work{'start_timer'} = psmisc::timer();
use sigtrap qw(handler safedie normal-signals error-signals INFO);

sub safedie {
  printlog( 'info', $0, make_stat() ), return if $_[0] eq 'INFO';
  printlog(
    'info', 'Signal ', @_,
    'recieved, flushing buffer, reloading conf.',
    ( %stat ? ( 'Stat: ', map { "$_=$stat{$_};" } keys %stat ) : () )
    ),
    #    $processor{'out'}{'array'}->()
    $static{'db'}->flush_insert(), psmisc::config_read(), psmisc::config_reload(), return
    if $_[0] eq 'HUP' and ( $config{'win_hup'} or $config{'system'} ne 'win' );
  printlog( 'info', 'Signal', @_, 'recieved, ignoring, not fatal?' ), return if $_[0] eq 'PIPE';
  printlog( 'info', 'Signal', @_, 'recieved, exiting' );
  #{
  #    local $config{'log_all'} = 1; #DEV
  #    printlog( 'info', 'executing on_interrupt', int(time) );
  $work{'on_interrupt'}->(@_) if ( !$work{'die'} and $work{'on_interrupt'} );
  #}
  $static{'db'}->{'die'} = $work{'die'} = 1;
  exit;
}

sub on_interrupt {
  $work{'on_interrupt'} = undef, return unless @_;
  $work{'on_interrupt'} = $_[0] if $_[0];
}

sub allowscan {
  my ( $by, $table, $tim, $period ) = @_;
  return 0 unless %$by;
  return 1 if $config{'force'};
  if (    #!$config{'sql _use_dbi'}    or
    $static{'banned'}->{ join_url($by) } or $static{'banned'}->{ $by->{'host'} } or $static{'banned'}->{ $by->{'range'} }
    )
  {

=c
printlog('dbg','allowscan:banned:', join_url($by),'ra=',$by->{'range'} , 'reason:',
"sud: ! $config{'sql _use_dbi'}
  banby:  or ",$static{'banned'}->{ join_url($by) },"
  ho  or ", $static{'banned'}->{ $by->{'host'} }, "
  ra  or ", $static{'banned'}->{ $by->{'range'} } , "
  ra h", %{$static{'banned'}->{ $by->{'range'} } }

);
=cut

    $static{'db'}->update( $table, undef, { %$by, 'scan' => int( time() ) + $config{'banned_time'} } )
      if $table and $config{'banned_time'};
    return 0;
  }
  #  my ( $tq, $rq, $vq ) = $static{'db'}->quotes();
  my $where = join(
    ' AND ',
    map( "$rq$_$rq = " . $static{'db'}->quote( $by->{$_} ),
      grep { %{ $config{'sql'}{'table'}{$table}{$_} or {} } and $config{'sql'}{'table'}{$table}{$_}{'primary'} } keys %$by )
  );
  #MAKE QUERY
  #printlog('dev', "tim($tim) per($period)", );
  my $base =
    ( $table
      and %$by
      and ( !$tim or !$period )
    ? $static{'db'}->line("SELECT ${rq}scan$rq, ${rq}period$rq FROM $tq$static{'db'}->{'table_prefix'}$table$tq WHERE $where")
    : {} );
  #printlog('dev', 'btim, bper = ', $base->{'scan'}, $base->{'period'});
  #printlog('dev', 'skiptime',join_url($by), $tim);
  $tim ||= $base->{'scan'};
  $work{'skiptime'}{ join_url($by) } = $tim;
  $period ||= ( $base->{'period'} or hconfig( 'period', $by->{'host'}, $by->{'prot'} ) );
  if ( !$tim or ( $tim < time - $period ) ) {
    local $config{'scan_timeout'} = $period / 2 if $config{'scan_timeout'} >= $period;
    $static{'db'}->update(
      $table, undef, {
        $static{'db'}->filter_row( $table, 'primary', $by ), (
          #          $period ne $base->{'period'} ? ( 'period' => $period ) : (),
          $config{'noscan'} ? () : ( 'scan' => int( time() ) - $config{'scan_timeout'} )
        )
      }
    ) if $table;
    #printlog('dbg','allowscan', join_url($by), psmisc::human('time_period',time - $tim), psmisc::human('time_period',$period));
    return 1;
  }
#else { printlog('dbg','NOT allowscan', join_url($by), psmisc::human('time_period',time - $tim), psmisc::human('time_period',$period)); }
  return 0;
}

sub resetcounters {
  ( $work{'sizec'}, $work{'filec'}, $work{'dirc'} ) =
    ( counter( $stat{'size'} ), counter( $stat{'files'} ), counter( $stat{'dirs'} ) );
}

sub uni_get {
  my ($what) = @_;
  my ($prot) = $what =~ m|^\s*(\w+):|;
  return $processor{'prot'}{$prot}{'get'}->($what) if $prot and $processor{'prot'}{$prot}{'get'};
  return $what;
}

sub oneliner {
  my ( $oneline, $content ) = @_;
  #  if ( $content =~ /^GLOB/ ) {
  if ( ref $content eq 'GLOB' ) {
    while (<$content>) { $oneline->(); }
    #  } elsif ( $content =~ /^ARRAY/ ) {
  } elsif ( ref $content eq 'ARRAY' ) {
    while ( defined( $_ = shift @$content ) ) { $oneline->(); }
  } else {
    for ( split( "\n", $content ) ) { $oneline->(); }
  }
}
$processor{'desc'}{'m3u'}{'func'} ||= sub {
  my ( $file, $data ) = @_;
  return unless $file;
  my ( $curdesc, %detectcp );
  open( DESC, '<', $file ) or return ();
  while (<DESC>) {
    cp_detect_trans( \$_, \%detectcp, undef, $config{'cp_m3u'} );
    if (/^#EXTINF:(\d+),(.+)/i) {
      $curdesc = '[' . $1 . 's] ' . $2;
      $curdesc =~ s/[\x0d\x0a\x00-\x1F]+/ /g;
    } elsif (/^(.+\..+)$/) {
      tr/A-Z/a-z/;
      s/[\x0d\x0a\x00-\x1F]//g;
      s/^\s+|\s+$//g;
      $data->{$_}{'desc'} .= ' ' . $curdesc;
    }
  }
  close(DESC);
  return $data;
};
$processor{'desc'}{'bbs'}{'func'} ||= sub {
  my ( $file, $data ) = @_;
  return unless $file;
  my $curfile = '';
  my %detectcp;
  open( DESC, '<', $file ) or return ();
  while (<DESC>) {
    if (/^-(.*)/) { next; }
    elsif (/^(\w\S*)\s*(\[\s*(\d*)\]\s*)?(.*)\s*/) {
      $curfile = $1;
      $curfile =~ tr/A-Z/a-z/;
      $curfile =~ s/\.$//g;
      my $desc = $4;
      $desc =~ s/[\x0d\x0a\x00-\x1F]+/ /g;
      cp_detect_trans( \$desc, \%detectcp, undef, $config{'cp_desc'} );
      $data->{$curfile}{'desc'} .= ' ' . $desc unless ( $desc =~ /^\s*$config{'nodesc'}\s*$/i );
    } else {
      next unless $curfile;
      next unless /^\s*(.+)/;
      next if length( $data->{$curfile}{'desc'} ) > 250;
      my $tmp = $1;
      $tmp =~ s/[\x0d\x0a\x00-\x1F]//g;
      chomp($tmp);
      next unless $tmp;
      cp_detect_trans( \$tmp, \%detectcp, undef, $config{'cp_desc'} );
      $data->{$curfile}{'desc'} .= '\\\\n' . $tmp;
    }
    # params load    $data{$curfile}{desc} = dos2win($data{$curfile}{desc}) if ( exists($data{$curfile}{desc}) );
    #                if ( exists($data{$curfile}{desc}) ) { #!!
    #                        while ($data{$curfile}{desc} =~ s/^\s*file(\S*)\=(\S*)\s*//i) {
    #                                $data{$curfile}{$1} = $2 if $1 and $2;
    #                        }
    #                }
  }
  close(DESC);
  return $data;
};

sub fileparser {    # $file, $prot, $full, $size, \%files    # $host,
  for my $dsk ( keys %{ $processor{'desc'} } ) {
    if ( $config{'desc'}{$dsk}{'mask'} and $_[0] =~ /$config{'desc'}{$dsk}{'mask'}/i ) {
      $processor{'desc'}{$dsk}{'func'}->( $processor{'prot'}{ $_[1] }{'get'}->( $_[2] ), $_[4] )
        if !$config{'desc'}{$dsk}{'max'}
          or $_[3] <= $config{'desc'}{$dsk}{'max'};
    }
  }
}

=cu

$processor{'out'}{'mysql'} ||= sub {
  return $static{'db'}->do(@_) if $config{'sql_use_dbi'};

  cut
  my @ret;
  for my $st (@_) {
    my $str = $st;                          # bugg
    my $q = ( $str =~ /\"/ ? "'" : '"' );
    $str =~ s/$q//g;
    $str =~ s/\`/\\`/g;
    printlog( 'dmp', "via mysql cmdline query {$str}" );
    my $up =
        ( $config{'sql_user'} ? "-u$config{'sql_user'} " : '' )
      . ( $config{'sql_pass'} ? "-p$config{'sql_pass'} " : '' )
      . ( $config{'sql_port'} ? "-P$config{'sql_port'} " : '' );
    push( @ret, `$config{'mysql'} $up $config{'sql_mysqlopt'} -e $q$str$q $config{'sql_base'}` );
  }
  return @ret;

};
=cut

=TODO
$processor{'out'}{'mysql_file'} ||= sub {
  printprog("$config{'mysql'} $config{'sql_mysqlopt'} $config{'sql_base'} < $_") for @_;
};

{
  my $gt = timer();
  $processor{'out'}{'sql'} ||= sub {
    my $ret;
    for my $str (@_) {
      next unless $str;
      if ( $config{'sql_use_dbi'} ) {
        my $t = timer() if $config{'debug_time'};
        $ret += $static{'db'}->do($str);
        printlog(
          'time',
          'SQL',
          psmisc::human( 'time_period', $t->() ),
          ',by',
          $ret,
          ( $t->() > 1 ? '=' . psmisc::human( 'float', $ret / $t->() ) . 'fps' : () ),
          ',SCAN=',
          psmisc::human( 'time_period', $gt->() ),
          ',',
          ( $gt->() > 1 ? '=' . psmisc::human( 'float', $ret / $gt->() ) . 'fps' : () )
        ) if $config{'debug_time'} and $config{'debug_time'} <= $ret;
        $gt = timer() if $config{'debug_time'};
      } else {
        open_out_file('hosts') unless $work{'current_name_work'};
        print I$str;
        ++$ret;
      }
    }
    return $ret;
  };
}

=cut

$processor{'format'}{'dir'} ||= sub {
  my $scan           = int( time() );
  my $curent_process = shift(@_);
  $curent_process =~ s/^(\S+:)?(\/*[^\/]+\/[^\/]+)\/(.+)$/$1$2/;
  return unless $curent_process;
  $curent_process =~ tr/\\/\//;
  my $path = $3;
  $path = $curent_process . '/' . $path;
  $path =~ s/[\\\/]+$//g;
  my $prot   = 'file';
  my $errors = 0;
BUG: for my $content (@_) {
    my %files = ();
    my ( $host, $dir_ ) = $curent_process =~ /^\/+([^\/]+)\/+([^\/]+)(.*)/;
    if ($host) {
      $files{''} = {
        'prot' => $prot,
        'host' => $host,
        ( hconfig( 'unknown_time', $host ) ne '' ? ( 'time' => int( time() ) - hconfig( 'unknown_time', $host ) ) : () ),
        'scan' => $scan
      };
      $files{' '} = {
        'prot' => $prot,
        'host' => $host,
        'path' => '/',
        ( hconfig( 'unknown_time', $host ) ne '' ? ( 'time' => int( time() ) - hconfig( 'unknown_time', $host ) ) : () ),
        'scan' => $scan
      };
      $files{'  '} = {
        'prot' => $prot,
        'host' => $host,
        'path' => '/',
        'name' => $dir_,
        ( hconfig( 'unknown_time', $host ) ne '' ? ( 'time' => int( time() ) - hconfig( 'unknown_time', $host ) ) : () ),
        'scan' => $scan
        }
        if $dir_;
    }
    my $oneline = sub {
      my ( $mday, $mon, $year, $hours, $min, $size, $file, $ext, $desc, $utime );
      if (/^ (Directory of|ন ) (.+)\s*$/) {
        $static{'db'}->insert_hash_hash( $config{'sql_tfile'}, \%files );
        %files = ();
        $path  = $2;
        $path =~ tr/\\/\//;
        $path =~ s/[\x0a\x0d\x00-\x1F]+//g;
        chomp($path);
        #          $path = cp_trans(hconfig('cp_share', $host), hconfig('cp_db', $host), $path);
        $path = cp_trans( hconfig( 'cp_res', $host, $prot ), hconfig( 'cp_db', $host, $prot ), $path );
        return;
      } elsif ( hconfig( 'skip_path_mask', $host ) and $path =~ /$config{'skip_path_mask'}/i ) {
        ++$stat{'skipped'};
        return;
      } elsif (/^\s*Total Files Listed/) {
        next BUG;
      } elsif ( /^  (.+) ᫨誮 ./ and ++$errors > hconfig( 'max_errors', $host, $prot ) ) {
        printlog( 'err', 'max errors reached:', $errors, $_ );
        last;
      }
      ( $mday, $mon, $year, $hours, $min, $size, $file ) = /(\d+)\.(\d+)\.(\d+)\s+(\d+)\:(\d+)\s+(\d+|\<DIR\>)\s+(.+)\s*/i
        or return;
      return if $size eq '0';
      $size = 0 if $size =~ /DIR/i;
      return if $file =~ /^\.+$/;
      $file =~ s/[\x0a\x0d\x00-\x1F]//g;
      $file =~ s/\.$//g;
      chomp($file);
      return if hconfig( 'skip_hidden', $host ) and ( $file =~ /^\./ or $path =~ m;(^|/)\.; );
      fileparser( $file, $prot, $path . '/' . $file, $size, \%files );
      $file = cp_trans( hconfig( 'cp_res', $host, $prot ), hconfig( 'cp_db', $host, $prot ), $file );
      my $lfile = $file;
      $lfile =~ tr/A-Z/a-z/;
      $files{$lfile}{'name'} = $file;
      $year += 2000 if length($year) == 2;
      $year = 1990 if ( ( $year > 2020 ) or ( $year < 1980 ) );    #timelocal BUG
      $files{$lfile}{'time'} = timelocal( 0, $min, $hours, $mday, --$mon, $year );
      $files{$lfile}{'time'}     = 640000000 if ( $files{$lfile}{'time'} > ( $scan + 2592000 ) );
      $files{$lfile}{'fullname'} = $prot . ':' . $path . '/' . $file;
      $files{$lfile}{'prot'}     = $prot;
      ( $files{$lfile}{'host'}, $files{$lfile}{'path'} ) = $path =~ /^?\/?\/?([^\/]+)(.+)/;
      $files{$lfile}{'ext'}  = ( $files{$lfile}{'name'} =~ s/\.([^\.]+)$// ? $1 : '' );
      $files{$lfile}{'scan'} = $scan;
      $files{$lfile}{'size'} = $size;
    };
    oneliner( $oneline, $content );
    $static{'db'}->insert_hash_hash( $config{'sql_tfile'}, \%files );
  }
};
$processor{'format'}{'smb-ls'} ||= sub {
  my $scan           = int( time() );
  my $curent_process = shift(@_);
  $curent_process =~ s/^(\S+:)?(\/*[^\/]+\/[^\/]+)\/(.+)$/$1$2/;
  return unless $curent_process;
  $curent_process =~ tr/\\/\//;
  my $path = $3;
  $path = $curent_process . '/' . $path;
  $path =~ s/[\\\/]+$//g;
  my $prot = 'file';

  for my $content (@_) {
    my %data  = ();
    my %files = ();
    my $root  = 0;
    my ( $host, $dir_ ) = $curent_process =~ /^\/+([^\/]+)\/+([^\/]+)(.*)/;
    if ($host) {
      $files{''} = {
        'prot' => $prot,
        'host' => $host,
        ( hconfig( 'unknown_time', $host ) ne '' ? ( 'time' => int( time() ) - hconfig( 'unknown_time', $host ) ) : () ),
        'scan' => $scan
      };
      $files{' '} = {
        'prot' => $prot,
        'host' => $host,
        'path' => '/',
        ( hconfig( 'unknown_time', $host ) ne '' ? ( 'time' => int( time() ) - hconfig( 'unknown_time', $host ) ) : () ),
        'scan' => $scan
      };
      $files{'  '} = {
        'prot' => $prot,
        'host' => $host,
        'path' => '/',
        'name' => $dir_,
        ( hconfig( 'unknown_time', $host ) ne '' ? ( 'time' => int( time() ) - hconfig( 'unknown_time', $host ) ) : () ),
        'scan' => $scan
        }
        if $dir_;
    }
    my $oneline = sub {
      my ( $mday, $mon, $year, $hours, $min, $sec, $size, $file, $ext, $desc, $utime, $attr );
      if (/^(\\.*)\s*$/) {
        $static{'db'}->insert_hash_hash( $config{'sql_tfile'}, \%files );
        %files = ();
        ( $path = $1 ) =~ s/\\+/\\/g;
        $path = cp_trans( hconfig( 'cp_res', $host, $prot ), hconfig( 'cp_db', $host, $prot ), $path );
        $path = $curent_process . $path;
        $path =~ tr/\\/\//;
        $path =~ s/[\x0a\x0d\x00-\x1F]//g;
        chomp($path);
        return;
      } elsif ( hconfig( 'skip_path_mask', $host ) and $path =~ /$config{'skip_path_mask'}/i ) {
        ++$stat{'skipped'};
        return;
      }
      ( $size, $mon, $mday, $hours, $min, $sec, $year ) = /\s+(\d+)\s+\w+\s+(\w+)\s+(\d+)\s+(\d+)\:(\d+)\:(\d+)\s+(\d+)\s*$/
        or return;
      $file = $`;
      $file =~ s/\s+([ADHSR]+)$//;
      $attr = $1;
      $file =~ s/(\s*$)|(^\s*)//g;
      return if $file =~ /^\.+\s*$/;
      return if hconfig( 'skip_hidden', $host ) and $attr =~ /H/;
      return if $size eq '0' and !$attr =~ /D/;
      $file =~ s/[\x0a\x0d\x00-\x1F]//g;
      $file =~ s/\.$//g;
      $file =~ s/\s*$//;
      chomp($file);
      return if hconfig( 'skip_hidden', $host ) and ( $file =~ /^\./ or $path =~ m;(^|/)\.; );
      $file = cp_trans( hconfig( 'cp_res', $host, $prot ), hconfig( 'cp_db', $host, $prot ), $file );
      fileparser( $file, $prot, $path . hconfig( 'slash_perl', $host ) . $file, $size, \%files );
      my $lfile = $file;
      $lfile =~ tr/A-Z/a-z/;
      $files{$lfile}{'name'} = $file;
      $year += 2000 if length($year) == 2;
      $year = 1990 if ( ( $year > 2020 ) or ( $year < 1980 ) );    #timelocal BUG
      $mon = $config{'lng'}{ $config{'lng_smbls'} }{'month_table'}{$mon} unless $mon =~ /^\d+$/;
      $files{$lfile}{'time'} = timelocal( $sec, $min, $hours, $mday, $mon, $year );
      $files{$lfile}{'time'}     = 640000000 if ( $files{$lfile}{'time'} > ( $scan + 2592000 ) );
      $files{$lfile}{'fullname'} = $prot . ':' . $path . '/' . $file;
      $files{$lfile}{'prot'}     = $prot;
      ( $files{$lfile}{'host'}, $files{$lfile}{'path'} ) = $path =~ /^?\/?\/?([^\/]+)(.+)/;
      $files{$lfile}{'ext'}  = ( $files{$lfile}{'name'} =~ s/\.([^\.]+)$// ? $1 : '' );
      $files{$lfile}{'scan'} = $scan;
      $files{$lfile}{'size'} = $size;
    };
    oneliner( $oneline, $content );
    $static{'db'}->insert_hash_hash( $config{'sql_tfile'}, \%files );
  }
};
$processor{'prot'}{'file'}{'toplevel'} ||= sub {
  return '' unless $config{'smbclient'} or $config{'net_view'};
  my ($host) = @_;
  shelldata($host);
  return unless $host =~ /\S/;
  my $prot = 'file';
  #--user=username[%password]
  my $h =
    openproc(
"$config{'starter'} $config{'net_view'} $config{'smbclient'} $config{'smb_opt'} $config{'view_opt'} \"$config{'slash_net'}$host\" $config{'stderr_redirect'} |"
    ) or return '';
  while (<$h>) {
    next unless /^\s*(.+)\s+((Disk)|()|(IPC))\s+(\w\:)?\s+(.*)\s*$/i;
    my ( $share, $desc ) = ( $1, $7 );
    $share =~ s/\s*$//g;
    next if hconfig( 'skip_hidden', $host ) and $share =~ /\$$/;
    $processor{'prot'}{'file'}{'scan'}->( '//' . $host . '/' . $share );
    if ( $desc =~ /\S/ ) {
      $share = cp_trans( hconfig( 'cp_res', $host, $prot ), hconfig( 'cp_db', $host, $prot ), $share );
      $desc =~ s/\s+$//;
      $desc = cp_trans( hconfig( 'cp_res', $host, $prot ), hconfig( 'cp_db', $host, $prot ), $desc );
      $static{'db'}->insert_hash_hash(
        $config{'sql_tfile'}, {
          '' => {
            'prot' => $prot,
            'host' => $host,
            'path' => '/',
            'name' => $share,
            ( hconfig( 'unknown_time', $host ) ne '' ? ( 'time' => int( time() ) - hconfig( 'unknown_time', $host ) ) : () ),
            'desc' => $desc,
            'scan' => int( time() )
          }
        }
      );
    }
  }
  close($h);
  return '';
};
$processor{'prot'}{'file'}{'scan'} ||= sub {
  my $prot = 'file';
  for my $where_bug (@_) {
    my $where = $where_bug;
    next if $where =~ /^\s*$/;
    printlog( 'smb', "$where : scanning..." );
    $where =~ s/\\|\//$config{'slash_dir'}/g;    #RO VALUE SOMETIMES
    $where =~ s/[\x0d\x0a\"]//g;
    my ($host) = $where =~ /([\w.]+)/;
    my $wheres = $where = cp_trans( hconfig( 'cp_res', $host, $prot ), hconfig( 'cp_shell', $host, $prot ), $where );
    my ($dir);
    ( undef, $where, $dir ) = $where =~ /^(\S+:)?(\/*[^\/]+\/[^\/]+)?\/?(.+)?\/?$/;
    $dir =~ s/\/+$//;
    $dir = '-D ' . $dir if $config{'smbclient'} and $dir;
    shelldata( $where, $dir );
    $where = qq|"$where"| if $where;
    $dir   = qq|"$dir"|   if $dir;
    #--user=username[%password]
    my $h =
      openproc(
"$config{'starter'} $config{'smbclient'} $config{'smb_opt'} $config{'dir_cmd'} $config{'smb_ls_opt'} $dir $where $config{'stderr_redirect'} |"
      ) or next;
    $wheres = cp_trans( hconfig( 'cp_shell', $host ), hconfig( 'cp_db', $host ), $wheres );
    $processor{'format'}{ hconfig( 'share_list_fmt', $host ) }->( $wheres, $h );
    close($h);
  }
};

sub purge_res {
  local $config{'purge_time'} = ( $config{'purge_res_time'} or $config{'period'} * 2 );
  $program{'purge'}{'func'}
    ->( undef, $config{'sql_tfile'}, 'AND ' . $static{'db'}->where_body( $_[0], undef, $config{'sql_tfile'} ) )
    if $config{'purge_every_res'};
}
$processor{'prot'}{'file'}{'func'} ||= sub {
  my $prot = 'file';
  for my $wheres (@_) {
    my %url = split_url($wheres);
    $wheres =~ s|^$prot://||i;
    $processor{'prot'}{$prot}{'scan'}->( (
          ( $wheres =~ m|[^/]+/[^/]+| or $wheres =~ m{^(\.|/)} )
        ? ( ( $wheres =~ m{^(\.|/)} ? '' : '//' ) . $wheres )
        : ( ( $wheres =~ /^\w\:/ ) ? $wheres : $processor{'prot'}{$prot}{'toplevel'}->($wheres) )
      )
    );
    purge_res( \%url ) if $config{'purge_every_res'};
  }
};
$processor{'prot'}{'file'}{'get'} ||= sub {
  return $_[0] if $config{'system'} =~ /win/i;
  my ( $file, $service, $save ) = @_;
  my $prot = 'file';
  $file =~ s/\|\>\<\"//g;
  ( undef, $service, $file ) = $file =~ /^(\S+:)?(\/*[^\/]+\/[^\/]+)\/(.+)$/;
  $save = encode_url( $prot . ':' . $service . '/' . $file, $config{'encode_url_file_mask'} );
  $file =~ s/\/+/\\\\/g;
  #      $file =~ s/\'/\'\'/g;       bbb u u ggg   ' symol in file name
  #      $file =~ s/\'/\\\'\\\'/g;   bbb u u ggg       !!!TODO test with "
  #      $file =~ s/\'/\\\'/g;       bbb uuu ggg
  return '' if $file =~ /\'/;
  my ($host) = $service =~ /([\w.]+)/;
  $file = cp_trans( hconfig( 'cp_db', $host, $prot ), hconfig( 'cp_res', $host, $prot ), $file );
  $save = hconfig('tmpdir') . hconfig( 'slash_sys', $host ) . $save;
  return $save if -e $save and -M $save < hconfig( 'get_file_cache_timeout', $host );
  shelldata( $file, $save, $service );
  printprog(
"$config{'starter'} $config{'smbclient'} $config{'smb_opt'} $config{'get_opt'} -c 'get \"$file\" \"$save\"' \"$service\" $config{'stderr_redirect'}",
    1
  );
  return $save;
};
{
  my ($ftp);
  $processor{'prot'}{'ftp'}{'get'} ||= sub {
    my ( $file, $save ) = @_;
    my %url = split_url($file);
    $save = encode_url( $file, $config{'encode_url_file_mask'} );
    $file = join_url( { 'path' => $url{'path'}, 'name' => $url{'name'}, 'ext' => $url{'ext'} } );
    $save = hconfig( 'tmpdir', $url{'host'} ) . hconfig( 'slash_sys', $url{'host'} ) . $save;
    $save =~ s/^(.{240}).*/$1/;
    return $save if -e $save and -M $save < hconfig( 'get_file_cache_timeout', $url{'host'} );
    $ftp =
      $work{'ftp'}
      { join_url( { 'user' => $url{'user'}, 'pass' => $url{'pass'}, 'host' => $url{'host'}, 'port' => $url{'port'} } ) };
    #printlog('dev' ,"1:$ftp;", %url);
    return if ftp_keep( $$ftp, %url );
    #printlog('dev' ,"2:$ftp;$$ftp;$$ftp;");
    eval { $$$ftp->get( $file, $save ); };
    return $save;
  };
  END { $$$ftp->close() if !ftp_check($$ftp); }
}
$processor{'prot'}{'rsync'}{'toplevel'} ||= sub {
  return '' unless $config{'rsync'};
  my ($host) = @_;
  shelldata($host);
  my %url = split_url($host);
  return unless $host =~ /\S/;
  my $h = openproc("$config{'starter'} $config{'rsync'} $config{'rsync_param'}  \"$host\" $config{'stderr_redirect'} |")
    or return '';
  while (<$h>) {
    next unless /(\S+)\s+(.*)\s*/;
    my ( $share, $desc ) = ( $1, $2 );
    $processor{'prot'}{'rsync'}{'scan'}->( $host . '/' . $share );
    if ( $desc =~ /\S/ ) {
      $share = cp_trans( hconfig( 'cp_rsync', $host ), hconfig( 'cp_db', $host ), $share );
      $desc =~ s/\s+$//;
      $desc = cp_trans( hconfig( 'cp_rsync', $host ), hconfig( 'cp_db', $host ), $desc );
      $static{'db'}->insert_hash_hash(
        $config{'sql_tfile'}, {
          '' => {
            %url,
            'path' => '/',
            'name' => $share,
            ( hconfig( 'unknown_time', $host ) ne '' ? ( 'time' => int( time() ) - hconfig( 'unknown_time', $host ) ) : () ),
            'desc' => $desc,
            'scan' => int( time() )
          }
        }
      );
    }
  }
  close($h);
  return '';
};
$processor{'prot'}{'rsync'}{'scan'} ||= sub {
  for my $where_bug (@_) {
    my $where = $where_bug;
    next if $where =~ /^\s*$/;
    printlog( 'rsync', "$where : scanning..." );
    shelldata($where);
    my %url = split_url($where);
    $where = cp_trans( hconfig( 'cp_rsync', $url{'host'} ), hconfig( 'cp_shell', $url{'host'} ), $where );
    my $h = openproc("$config{'starter'} $config{'rsync'} $config{'rsync_param'} \"$where\" $config{'stderr_redirect'} |")
      or next;
    $where = cp_trans( hconfig( 'cp_shell', $url{'host'} ), hconfig( 'cp_db', $url{'host'} ), $where );
    $processor{'format'}{'rsync'}->( $where, $h );
    close($h);
  }
};
$processor{'prot'}{'rsync'}{'get'} ||= sub {
  #TODO
};
$processor{'prot'}{'rsync'}{'func'} ||= sub {
  for my $wheres (@_) {
    my %url = split_url($wheres);
    $processor{'prot'}{'rsync'}{'scan'}->( ( ( $url{'path'} and $url{'path'} ne '/' ) or $url{'name'} )
      ? $wheres
      : $processor{'prot'}{'rsync'}{'toplevel'}->($wheres) );
    purge_res( \%url ) if $config{'purge_every_res'};
  }
};
$processor{'format'}{'rsync'} ||= sub {
  my $url = shift(@_);
  $url .= '/' unless $url =~ m|/$|;
  my %url  = split_url($url);
  my $scan = int( time() );
  my $path = $url{'path'};
  $path =~ s/[\\\/]+$//g;
  my $lastpath = $path;
  for my $content (@_) {
    my %data  = ();
    my %files = ();
    if ( $url{'host'} ) {    # ??
      my ($dir_) = $url{'path'} =~ /([^\/]+)/;
      $files{''} = {
        'prot' => $url{'prot'},
        'host' => $url{'host'}, (
          hconfig( 'unknown_time', $url{'host'} ) ne ''
          ? ( 'time' => int( time() ) - hconfig( 'unknown_time', $url{'host'} ) )
          : ()
        ),
        'scan' => $scan
      };
      $files{' '} = {
        'prot' => $url{'prot'},
        'host' => $url{'host'},
        'path' => '/', (
          hconfig( 'unknown_time', $url{'host'} ) ne ''
          ? ( 'time' => int( time() ) - hconfig( 'unknown_time', $url{'host'} ) )
          : ()
        ),
        'scan' => $scan
      };
      $files{'  '} = {
        'prot' => $url{'prot'},
        'host' => $url{'host'},
        'path' => '/',
        'name' => $dir_, (
          hconfig( 'unknown_time', $url{'host'} ) ne ''
          ? ( 'time' => int( time() ) - hconfig( 'unknown_time', $url{'host'} ) )
          : ()
        ),
        'scan' => $scan
        }
        if $dir_;
    }
    my $oneline = sub {
      chomp;
      s/[\x0a\x0d\x00-\x1F]//g;
      printlog( 'rsyncdmp', 'ol', $_ );
      my ( $mday, $mon, $year, $hours, $min, $sec, $utime, $attr );    #$size, $name ,$ext, $desc,
      my (%file);
      ( $attr, $file{'size'}, $year, $mon, $mday, $hours, $min, $sec, $file{'path'}, $file{'name'}, $file{'ext'} ) =
        m|^(\S+)\s+(\d+)\s+(\d+)/(\d+)/(\d+)\s+(\d+):(\d+):(\d+)\s+(?:(.+)/)?(.*?)(?:\.([^\.]+))?\s*$|
        or return;
      $file{'path'} = $path . ( $file{'path'} ? '/' : '' ) . $file{'path'};
      $file{'path'} =~ s/[\x0a\x0d\x00-\x1F]//g;

      if ( $lastpath ne $file{'path'} ) {
        printlog( 'rsyncdbg', 'path change from', $lastpath, $file{'path'}, 'uploaded', scalar %files );
        $static{'db'}->insert_hash_hash( $config{'sql_tfile'}, \%files );
        %files    = ();
        $lastpath = $file{'path'};
      }
      return if $file{'name'} =~ /^\.+\s*$/;
      return if $file{'size'} == 0 and !$attr =~ /^d/;
      $file{'size'} = 0 if $attr =~ /^d/;
      $file{'file'} = $file{'name'} . ( $file{'ext'} ? '.' : '' ) . $file{'ext'};
      return if hconfig( 'skip_hidden', $url{'host'} ) and ( $file{'file'} =~ /^\./ or $file{'path'} =~ m;(^|/)\.; );
      #        $file = cp_trans(hconfig('cp_rsync', $url{'host'}), hconfig('cp_db', $url{'host'}), $file);
      fileparser( $file{'file'}, $url{'prot'},
        $url{'prot'} . '://' . $file{'path'} . hconfig( 'slash_perl', $url{'host'} ) . $file{'file'},
        $file{'size'}, \%files );
      my $lfile = $file{'file'};
      $lfile =~ tr/A-Z/a-z/;
      ( $file{'prot'}, $file{'host'}, $file{'scan'} ) = ( $url{'prot'}, $url{'host'}, $scan );
      $year = 1990 if ( ( $year > 2020 ) or ( $year < 1980 ) );    #timelocal BUG
      $file{'time'} = 640000000
        if ( ( $file{'time'} = timelocal( $sec, $min, $hours, $mday, --$mon, $year ) ) > ( $scan + 2592000 ) );
      %{ $files{$lfile} } = %file;
    };
    oneliner( $oneline, $content );
    $static{'db'}->insert_hash_hash( $config{'sql_tfile'}, \%files );
  }
};
$processor{'format'}{'ls'} ||= sub {
  my $url = shift(@_);
  $url =~ tr/\\/\//;
  my ( $user, $pass, $host, $port, $path ) = @{ split_url($url) }{ 'user', 'pass', 'host', 'port', 'path' };
  my $prot = 'ftp';
  my (%files);
  for my $content (@_) {
    my $scan = int( time() );
    my $lfile;
    my $oneline = sub {
      s/[\x0a\x0d]//g;
      my ( $mday, $mon, $year, $hours, $min, $size, $file, $ext );
      if (/^\.?\/?(.*)\s*:\s*$/) {
        $path = $1;
        $static{'db'}->insert_hash_hash( $config{'sql_tfile'}, \%files ), %files = ();
        return;
      } elsif ( $config{'skip_path_mask'} and $path =~ /$config{'skip_path_mask'}/i ) {
        ++$stat{'skipped'};
        return;
      } elsif (/^\s*[rd\-]/) {
        ( $size, $mon, $mday, $hours, $min, $file ) =
          /^\s*\S+\s+\d*\s*\S+\s*\S*\s+(\d+)\s+(\S+)\s+(\d+)\s+(\d+):?(\d+)?\s+(.+)\s*$/;
        return if $file =~ /^\.+\s*$/;
        return if $size == 0 and !/^d/;
        $size = 0 if /^d/;
        $file =~ s/[\x0a\x0d\x00-\x1F]//g;
        $file =~ s/(\.|\s)*$//g;
        chomp($file);
        return if hconfig( 'skip_hidden', $host ) and ( $file =~ /^\./ or $path =~ m;(^|/)\.; );
        $lfile = $file;
        $lfile =~ tr/A-Z/a-z/;
        $files{$lfile}{'name'} = $file;
        $files{$lfile}{'size'} = $size;
        $mon                   = $config{'lng'}{ $config{'lng_ls'} }{'month_table'}{$mon};

        if ( $min eq '' ) {
          $year = $hours;
          $hours = $min = 0;
        } else {
          $year = ( localtime(time) )[5] + 1900;    #$curyear;
          --$year if $mon > ( localtime(time) )[4];
        }
        $year = 1990 if $year > 2020 or $year < 1980;    #timelocal BUG
        $mday = 28 if ( $mon == 1 and $mday > 28 ) or !$mday;    #Another bug 8(
        eval {                                                   #no more bugs 8)
          $files{$lfile}{'time'} = timelocal( 0, $min, $hours, $mday, $mon, $year );
        };
        $files{$lfile}{'time'} = 640000000 if ( $files{$lfile}{'time'} > ( $scan + 86400 ) );    # 2592000
      } else {
        return;
      }
      fileparser(
        $file, $prot,
        join_url( {
            'prot' => $prot,
            'user' => $user,
            'pass' => $pass,
            'host' => $host,
            'port' => $port,
            'path' => $path,
            'name' => $file
          }
        ),
        $size,
        \%files
      );
      $files{$lfile}{'fullname'} = join_url( {
          'prot' => $prot,
          'user' => $user,
          'pass' => $pass,
          'host' => $host,
          'port' => $port,
          'path' => $path,
          'name' => $file
        }
      );
      $files{$lfile}{'fullname'} =~ s/[\x00-\x1F]//g;
      $files{$lfile}{'desc'} = "cp=$_ " . $files{$lfile}{'desc'}
        if $_ = cp_detect_trans( \$files{$lfile}{'fullname'}, \%{ $work{$host}{'detectcp'} }, undef, undef, $prot, $host )
          and $_ ne hconfig( 'cp_res', $host, $prot );
      (
        $files{$lfile}{'prot'}, $files{$lfile}{'user'}, $files{$lfile}{'pass'}, $files{$lfile}{'host'},
        $files{$lfile}{'port'}, $files{$lfile}{'path'}, $files{$lfile}{'name'}, $files{$lfile}{'ext'}
      ) = @{ split_url( $files{$lfile}{'fullname'} ) }{ 'prot', 'user', 'pass', 'host', 'port', 'path', 'name', 'ext' };
      $files{$lfile}{'host'} = full_host( { 'host' => $host, 'user' => $user, 'pass' => $pass, 'port' => $port } );
      $files{$lfile}{'path'} ||= '/';
      $files{$lfile}{'scan'} = $scan;
    };
    oneliner( $oneline, $content );
  }
  $static{'db'}->insert_hash_hash( $config{'sql_tfile'}, \%files );
};

sub ftp_reconnect {
  my ( $ftp, %url ) = @_;
  $$ftp->close() if defined $$ftp;
  $work{'ftp_connected'} = 0;
  printlog(
    'hint',
    "FTP RECONNECTS1: host=$url{'host'} ftp_reconnects=$stat{'ftp_reconnects'} ftp_reconnect_max=",
    hconfig( 'ftp_reconnect_max', $url{'host'} ),
    'f=',
    $work{'filec'}->( $stat{'files'} ),
    'd=',
    $work{'dirc'}->( $stat{'dirs'} ),
    's=',
    $work{'sizec'}->( $stat{'size'} )
    ),
    return 3
    if ++$stat{'ftp_reconnects'} >= hconfig( 'ftp_reconnect_max', $url{'host'} );
  $$ftp = Net::FTP->new(
    $url{'host'},
    'Timeout' => hconfig( 'timeout', $url{'host'}, $url{'prot'} ),
    ( hconfig( 'passive', $url{'host'} ) ? ( 'Passive' => 1 ) : () ), ( $url{'port'} ? ( 'Port' => $url{'port'} ) : () )
  );
  return 1 if !defined $$ftp;
  my $message = $$ftp->message();
  #printlog('ftp', "FTP: message: $message");
  $message =~ s/\s+$//;
  if (
    !hconfig( 'ftp_recurse_force', $url{'host'} ) and !defined( $config{'fine'}{ $url{'host'} }{'ftp_recurse_force'} ) and (
      $message =~ /PureFTPd/i || $message =~ /Pure-FTPd/i    # PureFTPd sends only 2000 lines of "ls -lR"
      || $message =~ /CesarFTP/i                             # CesarFTP does not print "<DIRECTORY>:"
      || $message =~ /GuildFTPd/i                            # GuildFTPd gets crazy when attempting to use "ls -lR"
      || $message =~ /Microsoft/i                            # ??? can't parse output of "ls -lR" of Microsoft FTP server
      || $message =~ /Serv-U/i                               # Serv-U's "ls -lR" does not work well in all cases
      || $message =~ /Gene6 FTP Server/i
    )
    )
  {
    $config{'fine'}{ $url{'host'} }{'ftp_recurse_force'} = 1;
    printlog( 'ftp', "ftp_recurse_force=1 for $url{'host'}" );
  }
  if (
    !$$ftp->login(
      ( $url{'user'} or hconfig( 'anonymous_user', $url{'host'} ) ),
      ( $url{'pass'} or hconfig( 'anonymous_pass', $url{'host'} ) )
    )
    )
  {
    $$ftp->close() if defined $$ftp;
    printlog( 'ftp', "FTP: cannot login" );
    return 2;
  }
  printlog( 'ftp',
        "FTP: connected ($stat{'ftp_reconnects'}/"
      . hconfig( 'ftp_reconnect_max', $url{'host'} ) . ") to "
      . join_url( \%url )
      . " pasv="
      . hconfig( 'passive', $url{'host'} )
      . "; [$message]" );
  $work{'desc'}{ $url{'host'} }{'ftp'} = $message;
  ++$work{'ftp_connected'};
  $work{'ftp'}
    { join_url( { 'user' => $url{'user'}, 'pass' => $url{'pass'}, 'host' => $url{'host'}, 'port' => $url{'port'} } ) } = \$ftp;
  #$ftp;
  #    printlog("ftpis", "$ftp, $$ftp;");
  return 0;
}

sub ftp_reconnect_while {
  my ( $ftp, %url ) = @_;
  my $retry = 0;
  do {
    return 0 unless ftp_reconnect( $ftp, %url );    # !!!???
    return 2 unless $work{'ftp_connected'};
    printlog(
      'hint',
      "FTP RECONNECTS2: host=$url{'host'} ftp_reconnects=$stat{'ftp_reconnects'} ftp_reconnect_max=",
      hconfig( 'ftp_reconnect_max', $url{'host'} )
      ),
      return 3
      if $stat{'ftp_reconnects'} >= hconfig( 'ftp_reconnect_max', $url{'host'} );
    mysleep($_) if ( $_ = hconfig( 'ftp_reconnect_sleep', $url{'host'} ) );
    printlog( 'ftp',
          "FTP $url{'host'} reconnecting $retry ($stat{'ftp_reconnects'}/"
        . hconfig( 'ftp_reconnect_max', $url{'host'} )
        . ") [$@]" );
  } while ( $retry++ <= hconfig( 'ftp_reconnect_retry', $url{'host'} ) );
  return 1;
}

sub ftp_check {
  my ($ftp) = @_;
  return 1 unless ( defined $ftp and defined $$ftp and $ftp and $$ftp );
  my $code = $$ftp->code();
  return 2 if grep( $code eq $_, ( '599', '000', '200', '425', '150' ) );
  return 3 unless ( defined $ftp and defined $$ftp and $ftp and $$ftp );
  return 0;
}

sub ftp_keep {
  my ( $ftp, %url ) = @_;
  #  printlog('dev', 'ftp_keep', $ftp);
  return ftp_reconnect_while( $ftp, %url ) if ftp_check($ftp);
  return 0;
}

sub _list_cmd_ {    #from NET:FTP
  my $ftp = shift;
  my $cmd = 'LIST';
  my $res = pop;
  delete ${*$ftp}{'net_ftp_port'};
  delete ${*$ftp}{'net_ftp_pasv'};
  my $data = $ftp->_data_cmd( $cmd, @_ );
  return unless ( defined $data );
  require Net::FTP::A;
  bless $data, "Net::FTP::A";    # Force ASCII mode
  my $databuf = '';
  my $buf     = '';
  @_ = ();
  my $blksize = ${*$ftp}{'net_ftp_blksize'};

  while ( $data->read( $databuf, $blksize ) ) {
    $buf .= $databuf;
    for my $line ( split( /\n/, $buf ) ) {
      $processor{'format'}{'ls'}->( $res, \@_ ), @_ = () if @_ and $line =~ /\:\s*$/ and !$_[$#_];
      push @_, $line;            #if $line;
    }
    $buf = ( $buf !~ /\n$/ ? "\n" . pop @_ : '' );
  }
  $processor{'format'}{'ls'}->( $res, \@_ ) if @_;
  $data->close();
}
{
  my ( @toscan, $toscanfile );

  sub savearray {
    my ( $file, $arr ) = @_;
    return unless ( $file and $arr and open( TSO, '>', $file ) );
    while ( defined( $_ = shift @$arr ) ) { print TSO$_ . "\n" if $_; }
    close(TSO);
  }
  $processor{'prot'}{'ftp'}{'func'} ||= sub {
    #printlog( 'dbg', "prot'}{'ftp'}{'func" );
    foreach my $url (@_) {
      $url .= '/' if $url !~ m|/$|;
      my %url = split_url($url);
      my $ftp;
      $stat{'ftp_reconnects'} = $work{'ftp_connected'} = 0;
      next if ftp_keep( \$ftp, %url );
      my ($content);
      my $tryrec = 1;
      $stat{'ftp_errors'} = 0;

      unless ( hconfig( 'ftp_recurse_force', $url{'host'} ) ) {
        _list_cmd_(
          $ftp,
          "$config{'ls_opt'} $url{'path'}",
          join_url( {
              'user' => $url{'user'},
              'pass' => $url{'pass'},
              'host' => $url{'host'},
              'port' => $url{'port'},
              'path' => $url{'path'}
            }
          )
        );
        $tryrec = 0
          if ( $work{'filec'}->( $stat{'files'} ) > hconfig( 'ftp_recurse_threshold', $url{'host'} ) )
          and !ftp_check( \$ftp );
        if ( $config{'old_ftp_recurse'} and $tryrec ) {    #delete block
          printlog( 'dbg', "Old recurse" );
          $content = '';
          eval { $content = $ftp->dir("-lRGn $url{'path'}") };
          if ($content) {
            $tryrec = 0 if ( scalar @$content > hconfig( 'ftp_recurse_threshold', $url{'host'} ) ) and !ftp_check( \$ftp );
            $processor{'format'}{'ls'}->( join_url( \%url ), $content );
          }
        }
      }
      my $passive = 0;
      if ($tryrec) {
        printlog( 'ftp', "Trying recurse mode" ) unless hconfig( 'ftp_recurse_force', $url{'host'} );
        my $dir;
        @toscan     = ();
        $toscanfile = $config{'datadir'} 
          . $config{'slash_sys'}
          . encode_url(
          join_url( {
              'prot' => $url{'prot'},
              'user' => $url{'user'},
              'pass' => $url{'pass'},
              'host' => $url{'host'},
              'port' => $url{'port'}
            }
          )
          ) . '.toscan';
        if (  -e $toscanfile
          and rename( $toscanfile, $toscanfile . $config{'work_ext'} )
          and open( TSO, '<', $toscanfile . $config{'work_ext'} ) )
        {
          printlog( 'dbg', "Loading", $toscanfile );
          while (<TSO>) {
            s/^\s*//;
            s/\s*$//;
            my ($name) = m|/([^/]+)$|;
            printlog( 'dbg', 'toscan load skip path:', $_, $name ), next
              if $config{'skip_path_mask'} and $name =~ /^$config{'skip_path_mask'}$/i;
            push( @toscan, $_ );
          }
          close(TSO);
          unlink( $toscanfile . $config{'work_ext'} );
          my $where =
            $static{'db'}->where( { %url, ( $url{'path'} eq '/' ? ( 'path' => '' ) : () ) }, undef, $config{'sql_tresource'} );
          #          my ( $tq, $rq, $vq ) = $static{'db'}->quotes();
          my $res =
            $static{'db'}->line("SELECT * FROM $tq$static{'db'}->{'table_prefix'}$config{'sql_tresource'}$tq $where LIMIT 1");
          printlog( 'dev', 'ftptoscan stat: ', %$res );
          $stat{'dirs'}  += $res->{'dirs'};
          $stat{'files'} += $res->{'files'};
          $stat{'size'}  += $res->{'size'};
          printlog( 'dev', 'ftptoscan s: ', $stat{'dirs'}, $stat{'files'}, $stat{'size'} );
        } else {
          $dir = ( $url{'path'} or '/' );
          push( @toscan, $dir );
        }
        while (@toscan) {
          while ( $dir = pop(@toscan) ) {    #v1:shift v2:pop
            @toscan = (),
              printlog(
              'hint',
              "MAX ERRORS REACHED: host=$url{'host'} ftp_errors=$stat{'ftp_errors'} max_errors=",
              hconfig( 'max_errors', $url{'host'}, $url{'prot'} ),
              'f=',
              $work{'filec'}->( $stat{'files'} ),
              'd=',
              $work{'dirc'}->( $stat{'dirs'} ),
              's=',
              $work{'sizec'}->( $stat{'size'} ),
              $_
              ),
              printlog( 'warn', 'MAX ERRORS REACHED at', $url{'host'}, $dir, $_ ), last
              if $stat{'ftp_errors'} > hconfig( 'max_errors', $url{'host'}, $url{'prot'}, );
            #            printlog( 'ftpdbg', scalar @toscan, $dir );
            ++$stat{'ftp_errors'}, printlog( 'dbg', 'TOO LONG PATH', $dir, $_ ), next
              if length($dir) > hconfig( 'ftp_recurse_path_max', $url{'host'} );
            for my $retry ( 0 .. 3 ) {
              last if ftp_keep( \$ftp, %url ) or $work{'die'};
              #              printlog( 'ftpdbg', "trying change  to [$dir]" );
              $content = '';
              if ( $work{'die'} ) { last; }
              elsif ( hconfig( 'ftp_use_cwd', $url{'host'} ) ) {
                my $ret;
                eval { $ret = $ftp->cwd($dir); };
                if ($ret) {
                  eval { $content = $ftp->dir(); };
                } else {
                  printlog( 'dbg', "Cannot change to $dir" );
                  last;
                }
              } else {
                eval { $content = $ftp->dir($dir); };
              }
              local $_ = $ftp->pwd();
              s|/+$||;
              $_ = '/' . $_ if $_ and $_ !~ m|^/|;
              printlog( 'err', "CWD failed or PWD bug  mustbe:", $dir, "pwd:", $_ ) if ( $dir ne $_ ) and $_ and !m|^/\w\:|;
              $passive = 9, last if ( !ftp_check( \$ftp ) and $content ) or $work{'die'};
              printlog( 'dbg', "FTP getdir retry $retry " );    #, ++$passive, next if ftp_check(\$ftp);
              printlog( 'dbg', "Trying passive mode [$passive]" ), $config{'fine'}{ $url{'host'} }{'passive'} = 1
                if ( ++$passive == 1 )
                and !$config{'fine'}{ $url{'host'} }{'passive'};
              $ftp->pasv() if $passive == 1;
              ftp_reconnect( \$ftp, %url ) if $passive == 2 or $retry == 2;
              delete $config{'fine'}{ $url{'host'} }{'passive'} if $passive == 3;
            }
            ( $work{'ftp_connected'} ? next : last ) unless $content;
            my ( @thisdir, $listed_dirs, $num );
            for (@$content) {
              printlog( 'dmp', $_ );
              ++$stat{'ftp_errors'}, printlog( 'dbg', 'BUGGY FTPD ', $dir, $_ ), @thisdir = (), last
                if /^ftpd: .*: No such file or directory/i;
              ++$stat{'ftp_errors'}, printlog( 'dbg', 'BAD RECURSION SKIPPED [second listed dir]:', $dir, $1 ), @thisdir = (),
                last
                if /^\.?\/?(.+)\s*:\s*$/ and $listed_dirs++;
              next
                if !(/^\s*d\S+\s+\d*\s*\S+\s*\S*\s+(\d+)\s+(\S+)\s+(\d+)\s+(\d+):?(\d+)?\s+(.+)\s*$/)
                  or ( $6 =~ /^\.+[\s\xFF]*$/ )
                  or ( $6 =~ /^[\s\xFF]*$/ );
              my $name = $6;
              #              printlog( 'dev', 'name:', $name );
              $name =~ s/(^\s*)|(\s*$)//g;
              printlog( 'dbg', 'skip path:', $name ), next
                if $config{'skip_path_mask'} and $name =~ /^$config{'skip_path_mask'}$/i;
              my $add = $dir . ( $dir eq '/' ? '' : '/' ) . $name;
              ++$stat{'ftp_errors'}, printlog( 'dbg', 'BAD RECURSION SKIPPED [path dupes]:', $dir, $add ), next
                if $add =~ m|(/\Q$name\E){$config{'ftp_rec_path_dupes'},}$|;
              push( @thisdir, $add );    #v1:unshift v2:push
            }
            push( @toscan, @thisdir );
            unshift( @$content, $dir . ':' );
            $processor{'format'}{'ls'}->( join_url( \%url ), $content );
            $content = '';
            # !!! DIRS FILES !!!
            @toscan = (),
              printlog(
              'warn',
              "! recurse detected: $url{'host'} :",
              $work{'sizec'}->( $stat{'size'} ),
              $work{'filec'}->( $stat{'files'} )
              )
              if $work{'filec'}->( $stat{'files'} ) > hconfig( 'ftp_rec_max_number', $url{'host'} )
                and $work{'sizec'}->( $stat{'size'} ) / $work{'filec'}->( $stat{'files'} ) <
                hconfig( 'ftp_rec_min_size', $url{'host'} );
            last unless $work{'ftp_connected'};
          }
          last unless $work{'ftp_connected'};
        }
        if (@toscan) {
          ++$work{'scan_unfinished'};
          savearray( $toscanfile, \@toscan );
        }
      }
      $ftp->quit()       if defined $ftp;
      purge_res( \%url ) if $config{'purge_every_res'};
    }
  };
  END { savearray( $toscanfile, \@toscan ) if @toscan and $toscanfile; }
}
$processor{'format'}{'html'} ||= sub {
  my %outh;
  my $host = shift(@_);
  my $scan = int( time() );
  my $prot = 'http';
  my $desc;
  for my $content (@_) {
    my $oneline = sub {
      my @l = split /href/i;
      for (@l) {
        if (/^=([\"\'])((\w|[\.=\/:?&%\-])+)\1/i) {    #???
          #           my $url = decode_url($2);
          my $url = $2;
          #printlog('dev', 'hol:',$_);
          if ( $url =~ /^(http\:\/\/)/i ) {
            if ( $url =~ /^http\:\/\/$host/i )         #\w*\.?
            {
              if ( $url =~ /^http\:\/\/$host\/((\w|[\.\-])+)\/?/i ) {    #\w*\.?
                my $file = decode_url($1);
                ++$outh{$host}{$file}{'c'};
                #                 $outh{$host}{$file}{'desc'} = $desc;
                #                 $outh{$host}{$1}{'desc'} = cp_detect_trans(\$desc, \%detectcp, undef, $prot, $host);
              }
            }
          } elsif ( $url =~ /^(\S+\:\/\/)/i ) {
          } elsif ( $url =~ m{(?:^|/)((\w*[\.\-\%]*)+)(?:$|/)} ) {
            #            } elsif ($url =~ m{((\w*|[.\-%]*)+)}){
            #printlog('dev', $host," url1:[$url] -> [$1]");
            my $file = decode_url($1);
            #printlog('dev', $host,' url2:',$url, " : $file");
            ++$outh{$host}{$file}{'c'};
            #                 $outh{$host}{$file}{'desc'} = $desc;
            #                 $outh{$host}{$1}{'desc'} = cp_detect_trans(\$desc, \%detectcp, undef, $prot, $host);
          }
        }
      }
    };
    oneliner( $oneline, $content );
  }
  for my $host ( keys %outh ) {
    for my $rr ( keys %{ $outh{$host} } ) {
      next if $rr =~ /cgi-bin/i;
      my %url = split_url( $prot . '://' . $host . '/' . $rr );
      $static{'db'}->insert_hash_hash(
        $config{'sql_tfile'}, {
          '' => {
            %url,
            'size' => ( $url{'ext'} ? 1 : 0 ), (
              hconfig( 'unknown_time', $url{'host'} ) ne ''
              ? ( 'time' => int( time() ) - hconfig( 'unknown_time', $url{'host'} ) )
              : ()
            ),
            'desc' => $outh{ $url{'host'} }{$rr}{'desc'},
            'scan' => $scan
          }
        }
      );
    }
  }
};
$processor{'prot'}{'http'}{'get'} ||= sub {
  local $config{'cachedir'} = $config{'tmpdir'};
  return http_get( $_[0], 1 );
};
$processor{'prot'}{'http'}{'func'} ||= sub {
  my $scan = int( time() );
SKIP0: for my $url (@_) {
    next unless $url =~ /\S/;
    $url =~ s/\/+$//;
    my %url     = split_url($url);
    my @content = ( http_get($url) );
    my %detectcp;
    if ( $content[0] =~ /\<.+\>/ ) {
      for my $skipmask ( @{ $config{'http_skip'} } ) { next SKIP0 if $content[0] =~ /$skipmask/i; }
      my ($desc) = $content[0] =~ /\<title.*\>\s*(.+)\s*\<\/title\s*\>/is;
      cp_detect_trans( \$desc, \%detectcp, undef, undef, $url{'prot'}, $url{'host'} );
      $work{'desc'}{ $url{'host'} }{ $url{'prot'} } = $desc;
      $processor{'format'}{'html'}->( $url{'host'}, \@content );
      $stat{'dirs'}  += 1;
      $stat{'files'} += 1;
      $stat{'size'}  += 1;
    }
  }
};

sub updateuser {
  my ( $dc, $user, $params ) = @_;
  #  printlog( 'dbg', 'skipping user', $user, 'with share =', $dc->{'NickList'}->{$user}{'sharesize'} ),
  return if !$dc->{'NickList'}->{$user}{'sharesize'} and length $user;
  if ($user) {
    $params->{'ip'} ||= $dc->{'NickList'}->{$user}{'ip'};
    $params->{'desc'} ||= $dc->{'NickList'}->{$user}{'description'} if $dc->{'NickList'}->{$user}{'description'};
  }
  $params->{'desc'} =~ s/^(?:\s*(?:\{\S*?\})?(?:\[\S*?\])?)+//g;
  $params->{'desc'} =~ s/^\s*(?:\[\S+?\])\s*PeerWeb\s*DC\+\+\s*//ig;
  $params->{'prot'}   ||= 'dchub';
  $params->{'dcuser'} ||= $user;
  $params->{'host'} = full_host( {%$dc} );    #, %$params
  #  printlog('dev',' host= ',$params->{'host'},'from',$dc->{'host'} ,$dc->{'port'},'and',%$params);
  $params->{'time'} ||= ( $params->{'off'} ? int( time() ) - $config{'online_minutes'} * 120 : int( time() ) )
    unless $params->{'no_time'};
  #  printlog('dev','timeup',$params->{'dcuser'}, $params->{'time'}, int(time()));
  $params->{'host'}   = cp_trans( $config{'cp_dc_hub'}, $config{'cp_db'}, $params->{'host'} );
  $params->{'dcuser'} = cp_trans( $config{'cp_dc_hub'}, $config{'cp_db'}, $params->{'dcuser'} );
  $params->{'desc'}   = cp_trans( $config{'cp_dc_hub'}, $config{'cp_db'}, $params->{'desc'} );
  $static{'db'}->update( $config{'sql_tresource'}, undef, { 'path' => '', %$params } ) unless $params->{'no_res'};    #, 1
  unless ( $params->{'no_file'} ) {
    $static{'db'}->update( $config{'sql_tfile'}, undef, { 'path' => $_, %$params } )
      for ( '', '/' );
  }
  $params->{'port'} ||= $dc->{'NickList'}->{$user}{'port'} if $user and $config{'allow_ping_user_port'};
  delete $params->{'port'} if $params->{'port'} > 65535;
  #  printlog('dev', 'update', %$params);
  $static{'db'}->update( $config{'sql_thost'}, undef, $params );    #, 1 'ip' => $ip,
}
$processor{'prot'}{'dchub'}{'func'} ||= sub {
  my ($filelists) = $stat{'filelists'};
  my $dc;
  foreach my $url (@_) {
    my %url = split_url($url);
    #printlog('split:', Dumper(\%url));
    $url{'dcuser'} = $1 if $url{'host'} =~ s|/(.+)||;
    my $hub = join_url( { 'host' => $url{'host'}, 'port' => $url{'port'} } );
    #    next if $config{'dchub'}{$hub}{'disabled'};
    next if hconfig( 'disabled', 'dchub', $hub );
    printlog( 'dc', "Creating bot ver", ( $config{'version'} or 'r' . ( split( ' ', '$Revision: 4097 $' ) )[1] ) );
    $dc = dcppp::clihub->new(
      'log' => \&printlog,
      %{ $config{'fine'}{'dchub'} }, %url, %{ $config{'fine'}{$hub} }, 'auto_connect' => 0,
    );
    $dc->{'sharesize'} = psmisc::human( 'number_k', $dc->{'sharesize'} );
    my $nicklistres = 1 if $url{'dcuser'};
    $dc->{'handler'}{'NickList'} = sub {
      my $dcu = shift;
      updateuser( $dc, $_ ) for keys %{ $dc->{'NickList'} };
      printlog( 'dc', "Nicklist recieved = ", scalar keys %{ $dc->{'NickList'} } );
      $nicklistres = 1;
    };
    $dc->{'handler'}{'MyINFO'} = sub {
      my $dcu = shift;
      ($_) = $_[0] =~ /\S+\s+(\S+)\s+(.*)/;
      updateuser(
        $dc, $_, (
          hconfig( 'dcbot_size_myinfo', $hub )
            && $dc->{'NickList'}->{$_}{'sharesize'} > 0 ? { ( 'size' => $dc->{'NickList'}->{$_}{'sharesize'} ) } : ()
        )
      );
    };
    $dc->{'handler'}{'chatline'} = sub {
      my $dcu = shift;
      ($_) = $_[0] =~ /^<(\S+)>/;
      updateuser( $dc, $_ ) if $dc->{'NickList'}->{$_} or $config{'dcbot_update_unknown'};    #Hub-Security
    };
    $dc->{'handler'}{'welcome'} = sub {
      my $dcu = shift;
      printlog( 'dc', 'welcome:', scalar cp_trans( $config{'cp_dc_hub'}, $config{'cp_log'}, $_[0] ) );
    };
    $dc->{'handler'}{'quit'} = sub {
      my $dcu = shift;
      updateuser( $dc, $_, { 'off' => 1 } );
    };
    $dc->{'handler'}{'BadPass'} = sub {
      my $dcu = shift;
      printlog( 'err', 'BadPassword' );
    };
    $dc->{'handler'}{'LogedIn'} = sub {
      my $dcu = shift;
      printlog( 'dbg', $_[0], 'is LogedIn' );
    };
    $dc->{'handler'}{'user_ip'} = sub {
      my $dcu = shift;
      #printlog('dev', 'hUserip', @_);
      updateuser( $dc, $_[0],
        { 'ip' => $_[1], ( $_[2] != 411 ? ( 'port' => $_[2] ) : () ), 'no_res' => 1, 'no_file' => 1, 'no_time' => 1 } )
        if $_[1] ne name_to_ip( $url{'host'} );
    };
    $dc->{'auto_recv'} = 0 if $url{'dcuser'};
    printlog( 'dc', "Connecting to", $url );
    $dc->connect();
    next unless $dc->{'socket'};
    $dc->wait(10) for 1 .. 5;
    #1    while !$dc->recv(1);
    printlog( 'dbg', "connected" );
    if ( !$url{'dcuser'} and !$nicklistres and !$dc->{'auto_GetNickList'} ) {
      printlog( 'dbg', "Get nicks" );
      $dc->cmd('GetNickList');
      next unless $dc->{'socket'};
      my $trynickres = 50;
      #      $dc->recv(1), sleep(0.1) while --$trynickres > 0 and !$nicklistres;
      $dc->wait(10) while --$trynickres > 0 and !$nicklistres;
    }
    #    printlog( 'dbg', "nicks:", $nicklistres, );
    printlog( 'dbg', "Starting [$dc->{'host'} : $dc->{'port'}]" );
    my $saveto =
        $config{'datadir'}
      . $config{'slash_sys'}
      . $dc->{'host'}
      . ( $dc->{'port'} != 411 ? '.' . $dc->{'port'} : '' )
      . '.dchub';
    $dc->recv();
    next unless $dc->{'socket'};
    printlog( 'dbg', "Starting users", ( $url{'dcuser'} or scalar keys %{ $dc->{'NickList'} } ) );
    my $hubhost = $url{'host'};
    my $hubport = $url{'port'};
    my $n;

    for my $user ( $url{'dcuser'} || ( sort keys %{ $dc->{'NickList'} } ) ) {
      ++$n;
      my $get = 1;
      $url{'dcuser'} = $user;
      $url{'host'} = full_host( { %url, 'host' => $hubhost, 'port' => $hubport } );
      #      printlog('split:', Dumper(\%url));
      my %url_db = %url;
      cp_trans_hash( $config{'cp_dc_hub'}, $config{'cp_db'}, \%url_db );
      my $file =
        encode_url( scalar cp_trans( $config{'cp_dc_hub'}, $config{'cp_shell'}, $user ), $config{'encode_dc_user_mask'} );
#        printlog( 'dev', "1user=$url{'dcuser'}; host=$url{'host'}; get=$get; config{'no_dcbot_download'}=$config{'no_dcbot_download'}" );
      if ( !hconfig( 'no_dcbot_download', $hub, $user ) ) {
        printlog( 'dbg', 'looking at', $url{'host'}, '/', $url{'dcuser'}, ' filelist:',
          -s $saveto . $config{'slash_sys'} . $file . '.xml.bz2',
          $n, '/', scalar keys %{ $dc->{'NickList'} } );
        #        printlog( 'dbg', "skip [$user] (filelist exists)" ), $get = 0
        #          if
        #          ( !hconfig( 'forceforce', $hub ) and -s $saveto . $config{'slash_sys'} . $file . '.xml.bz2' );
        printlog( 'dbg', "skip [$user] (scanned)" ), $get = 0
          if ( $user eq $dc->{'Nick'} )
          or ( !hconfig( 'forcedc', $hub, $user ) and -s $saveto . $config{'slash_sys'} . $file . '.xml.bz2' )
          or !allowscan( \%url_db, $config{'sql_tresource'}, undef, $config{'dcbot_client_period'} );
      }
      $dc->cmd( 'GetINFO', $user ), $dc->recv()
        if !hconfig( 'dcbot_no_getinfo', $hub, $user ) and !$dc->{'NickList'}->{$user}{'info'};    #, $dc->recv()
      if ( !hconfig( 'no_dcbot_download', $hub, $user ) ) {
        printlog( 'dbg', "skip [$user] (share $dc->{'NickList'}->{$user}{'sharesize'} bytes)" ), $get = 0
          if !hconfig( 'forcedc', $hub, $user )                                                    #!$config{'force'}
            and defined( $dc->{'NickList'}->{$user}{'sharesize'} ) and !$dc->{'NickList'}->{$user}{'sharesize'};
        printlog( 'dbg', "skip [$user] unable get from passive user" ), $get = 0
          if $dc->{'M'} eq 'P' and $dc->{'NickList'}->{$user}{'M'} eq 'P';
        printlog( 'dbg', "skip [$user] no free user slots ($dc->{'NickList'}->{$user}{'S'})" ), $get = 0 if   #!$config{'force'}
          !hconfig( 'forcedc', $hub, $user ) and $dc->{'NickList'}->{$user}{'S'} eq '0';
      }
#        printlog( 'dev', "2user=$url{'dcuser'}; host=$url{'host'}; get=$get; config{'no_dcbot_download'}=$config{'no_dcbot_download'}" );
      if ( !hconfig( 'no_dcbot_download', $hub, $user ) and $get ) {
        printlog( 'dc',  "Get filelist from [$user]" );
        printlog( 'dbg', "get: [$saveto . $config{'slash_sys'} . $file] user=$user" );
        mkdir_rec( $saveto, 0777 );
        $dc->get( $user, '', $saveto . $config{'slash_sys'} . $file );                                        #.get
        ++$stat{'filelists'};
        #        printlog( 'dc',  "sleep", hconfig( 'dcbot_pause',  $hub ) );
        #$dc->wait(1, hconfig( 'dcbot_pause',  $hub )) and
        #$dc->wait(10, 0.1) for 0..5;
        $dc->wait_sleep( hconfig( 'dcbot_pause', $hub ) );
        #sleep hconfig( 'dcbot_pause',  $hub );
        #        sleep $config{'dcbot_pause'};
      } elsif ( $config{'force_ip_collect'}
        and ( $dc->{'NickList'}->{$user}{'M'} ne 'P' )
        and ( ( $dc->{'M'} ne 'P' ) or $dc->{'allow_passive_ConnectToMe'} ) )
      {                                                                                                       #to do to dcpp lib
        printlog( 'dc', 'trying connect to us', $user );
        $dc->cmd( 'Rev' . 'ConnectToMe', $user );
      }
      #      $dc->info();
      printlog( 'err', 'hub socket closed!' ), $dc->info(), last unless $dc->{'socket'};
    }
    my $share;
    $share += $dc->{'NickList'}{$_}{'sharesize'} for keys %{ $dc->{'NickList'} };
    $share = psmisc::human( 'size', $share );
    updateuser(
      $dc, '', {
        %$dc,
        'desc' => ( scalar keys %{ $dc->{'NickList'} } or 0 ) . ' users ' . $share . ' ' . $dc->{'HubName'},
        'scan' => int( time() )
      }
    );
    printlog( 'dbg', 'ended, aftersleep' );
    #    $dc->wait(100,1) for ( 0 .. 60 );
    $dc->wait_sleep(10) if $url{'dcuser'};
    $dc->wait_finish();
    printlog( 'dc', 'Finished' );
    $dc->destroy();
    #todo: hubstat
    #printlog('info', $dc->{'IpList'});
    #printlog('info', $dc->{'NickList'});
    #    for( keys %{ $dc->{'IpList'} } ) {
##printlog('dev', "ip=$_, nick=",$dc->{'IpList'}->{$_}{'Nick'}, 'port=',$dc->{'IpList'}->{$_}->{'port'});
    #      printlog('dbg','updating info about user ip:', $dc->{'IpList'}->{$_}{'Nick'}, $_),
    #      updateuser($dc, $dc->{'IpList'}->{$_}->{'Nick'}, {'ip' => $_,
    #                 'port' => $dc->{'IpList'}->{$_}->{'port'},
    #                 'no_res' => 1, 'no_file' => 1, 'no_time' => 1});
    #    }
    $processor{'file'}{'dchub'}{'func'}->($saveto) unless hconfig( 'no_dcbot_upload', $hub );
  } continue {
    #    $dc = undef;
    $dc->destroy() if $dc;
    #    printlog('dev', Dumper($dc));
    undef $dc;
  }
  $work{'proc_scans'} -= $stat{'filelists'} - $filelists;
};
$processor{'prot'}{'dchub'}{'get'} ||= sub {
  #TODO
};
$processor{'format'}{'nmap'} ||= sub {
  my $nping = shift @_;
  my ( $host, $hostip, $hostname );
  my @resbuffer;
  $nping = $nping =~ /-P0/;
  for my $content (@_) {
    my ( $hostup, $resolvs );
    my $oneline = sub {
      chomp;
      s/[\x0d\x0a]+//g;
      if ( s/Host\s+(\S*)\s+(:?\((\S+)\)\s*)?appears to be up/($hostip, $hostname) = ($2, $1),    $&/ei
        or s/Host:\s*(\S+)\s*(\S*)\s*(Status: Up|Ports:)/($hostip, $hostname) = ($1, $2),    $&/ei
        or s/Interesting ports on (\S*) \((\S+)\)/       ($hostip, $hostname) = ($2, $1),    $&/ei
        or s/Interesting ports on (\S+):/                ($hostip, $hostname) = ($1, undef), $&/ei
        or s/Discovered open port \S+\/tcp on (\S+)/     ($hostip, $hostname) = ($1, undef), $&/ei )
      {
        $hostip   ||= $hostname;
        $hostname ||= $hostip;
        $host = ( ( !$config{'nmap_nores'} and $hostname ) ? $hostname : $hostip );
        $host =~ s/\(|\)//g;
        return if !$host or $host =~ /^\d$/;
        $hostup = 1 unless $nping;
        $resolvs = 0;
      } elsif (/^\s*Nmap finished: (\d+) IP addresses \((\d+) hosts up\) scanned in \S+ seconds/) {
        $work{'range_size'} = $1;
      } elsif (/^\s*Raw packets sent: (\d+) \((\S+)\) \| Rcvd: (\d+) \((\S+)\)/) {
        #count traffic bytes?
      }
      if (/(\S+)\/tcp\s+(open|on)/i) {
        my ( $port, $prot ) = ( $1, $static{'port2prot'}{$1} );
        return if $config{'scanner'}{$prot}{'disabled'} or !$host;
        $host = normalize_ip($host) if $config{'host_by_name_norm'} and !$resolvs++;
        push( @resbuffer, $prot . '://' . $host ) unless $config{'nmap_only'};
        $static{'db'}->update( $config{'sql_tresource'}, undef, { 'prot' => $prot, 'host' => $host } )
          unless ( $static{'banned'}->{ $prot . '://' . $host } or $static{'banned'}->{$host} );
        $processor{'urls'}->(@resbuffer), @resbuffer = () if $#resbuffer >= $config{'start_by'} - 1;
        $hostup = 1 if $nping;
        ++$ipstt{'resalive'}{$host};
      }
      if ($hostup) {
        $static{'db'}->update( $config{'sql_thost'}, undef, { 'host' => $host, 'ip' => $hostip, 'time' => int( time() ) } );
        ++$ipstt{'alive'}{$host};
        ++$ipstt{'ralive'}{$host};    # not optimal!
        $hostup = 0;
      }
    };
    oneliner( $oneline, $content );
  }
  $processor{'urls'}->(@resbuffer) if @resbuffer;
};
$processor{'url'} ||= sub {
  my @rng = @_;
  #  printlog('dev', '$processor{url}', @_);
  %ipstt = ();
  @rng = reverse(@rng) if $config{'ranges_reverse'};
  shuffle( \@rng ) if $config{'ranges_shuffle'};
  my $ranges = 0;
  for my $range (@rng) {
    ++$ranges;
    $range =~ s/^\s+|\s+$//g;
    next if !$range or $range =~ /^[;#]/;
    my ($desc) = $1 if $range =~ s/\s+(.+)//;
    $range = '\\\\' . $range if $range =~ /^((\.)|(\w\:[^\/\\])|(\\[^\\]))/;    #    |(\/[^\/])!!!   |((\\)|(\/)$)
    $range =~ tr/\\/\// if $range =~ s/^\s*(\\\\|\/\/)/file:\/\//;
    my $tim = timer();
    #todo $range = 'range://'    unless ( $range =~ /\:\/\// );
    #printlog('dev', '$processor{url}2', $range);
    if ( $range =~ /\:\/\// ) { $processor{'scan_proto_host'}->($range); next; }
    next
#      unless allowscan( { 'range' => $range, 'desc' => $desc }, $config{'sql_tranges'}, undef, $config{'range_period'} );
#      unless allowscan( { 'range' => $range, 'desc' => $desc }, $config{'sql_tranges'}, undef, hconfig('range_period', $range) );
      unless allowscan( { 'range' => $range, 'desc' => $desc }, $config{'sql_tranges'}, undef,
          hconfig( 'period', $range, 'range' ) );
    next if $config{'noscan'};
    ( $ipstt{'ralive'}, $ipstt{'resalive'} ) = ();
    printlog( 'nmap', "scanning $range [", $ranges, '/', $#rng + 1, ']' );
    state( "scan:", $range );
    my $nmap_myip;
    $nmap_myip = '-S ' . $config{'myip'}
      if $config{'myip'}
        and $config{'get_myip_mask'}
        and $range =~ /$config{'get_myip_mask'}/;
    my $port = join ',',
      map { $config{'scanner'}{$_}{'port'} }
      grep { $config{'scanner'}{$_}{'port'} and !$config{'scanner'}{$_}{'disabled'} and !$config{'scanner'}{$_}{'no_nmap'} }
      keys %{ $config{'scanner'} };
    $port = $config{'nmap_param_port'} . ' ' . $port if $port and $config{'nmap_param_port'} and !$param->{'pingonly'};
    my $scantype = ($port) ? $config{'nmap_scan'} : $config{'nmap_ping'};
    shelldata($range);
    state( "scan range: $range", );
    on_interrupt(
      sub {
        $static{'db'}->update(
          $config{'sql_tranges'},
          undef, {
            'range' => $range,
            #      'scan'  => int( time() + hconfig('on_interrupt', $range) - hconfig('range_period', $range)),
            'scan' => int( time() + hconfig( 'on_interrupt', $range ) - hconfig( 'period', $range, 'range' ) ),
          }
        );
      }
    ) if hconfig( 'on_interrupt', $range );
    my $h =
      openproc(
"$config{'starter'} $config{'nmap'} $scantype $port $config{'nmap_param'} $config{'nmap_nores'} $nmap_myip $range $config{'stderr_redirect'} |"
      ) or next;
    $processor{'format'}{'nmap'}->( $config{'nmap_param'}, $h );
    on_interrupt();
    close($h);
    my $ips = ( 2**( 32 - $1 ) ) if !$work{'range_size'} and $range =~ m|^\s*\d+\.\d+\.\d+\.\d+/(\d+)\s*$|;
    $ips = $work{'range_size'} if $work{'range_size'};
    $work{'range_size'} = 0;
    %_ =
      ( 'range' => $range, 'scan' => int( time() ), 'alive' => scalar( keys %{ $ipstt{'ralive'} } ), 'size' => ( $ips or 1 ) );
    $_{'time'} = int( time() ) if scalar( keys %{ $ipstt{'ralive'} } );
    $static{'db'}->update( $config{'sql_tranges'}, undef, \%_ );
    my $t = $tim->();
    my $ipps = $ips / $t if $t > 0;
    ( $ipps = sprintf( "%.3f", $ipps ) ) .= ' ipps' if $ipps;
    $ips = " [$ips] " if $ips;
    printlog(
      'nmap',
      "finished $range $ips alive:",
      scalar( keys %{ $ipstt{'ralive'} } ),
      ', resalive:', scalar( keys %{ $ipstt{'resalive'} } ),
      ' per', psmisc::human( 'time_period', $t ), $ipps
    );
    ++$work{'scans'};
  }
};
$processor{'prot'}{'range'}{'func'} ||= sub { printlog( 'dev', '$processor{range}', @_ ); };
$processor{'scan_proto_host'} ||= sub {
  for my $url (@_) {
    #printlog('dev', '$processor{scan_proto_host}', $url);
    $url =~ s/\s+$//;
    my %url = split_url($url);
    #printlog('dev', '$processor{scan_proto_host}', %url);
    #printlog('dev', '$processor{scan_proto_host}', join_url(\%url));
    $url{'host'} = normalize_ip( $url{'host'} )
      if $url{'host'}
        and $url{'prot'} ne 'range'
        and hconfig( 'host_by_name_norm',       $url{'host'}, $url{'prot'} )
        and hconfig( 'host_by_name_norm_force', $url{'host'}, $url{'prot'} )
        and !( $config{'norm_skip_host'} and $url{'host'} =~ /$config{'norm_skip_host'}/i );
#printlog('dev', '$processor{scan_proto_host}3', %url, $config{'scanner'}{ $url{'prot'} }{'disabled'}, $config{'scanner'}{ $url{'prot'} }{'func'});
    next if $config{'scanner'}{ $url{'prot'} }{'disabled'} or !$url{'host'} or !$processor{'prot'}{ $url{'prot'} }{'func'};
    $url{'path'} = '' if $url{'path'} eq '/';
    $url = join_url( \%url );
    my $desc;    #todo
    my $table = $url{'prot'} eq 'range' ? $config{'sql_tranges'} : $config{'sql_tresource'};
    my %res = $url{'prot'} eq 'range' ? ( 'range' => $url, 'desc' => $desc ) : ( %url, 'host' => full_host( \%url ), );
    #printlog('dev', '$processor{scan_proto_host}2', %res);
    printlog(
      'dbg',
      "Skipping $url (scanned",
      psmisc::human( 'time_period', int( time() ) - $work{'skiptime'}{$url} ),
      ' ago)'
      ),
      next
      if (
      !allowscan(
        \%res, $table, undef, ( ( $url{'prot'} eq 'dchub' and $url{'host'} =~ m|/| ) ? $config{'dcbot_client_period'} : undef )
      )
      );
    next if $config{'noscan'};
    #    } else {
    #        if !$config{'noscan'};
    #    {
    local $config{'force'} = 0 if $work{'scan_proto_host_reset_force'};
    resetcounters();
    $work{'scan_unfinished'} = 0;
    state( "scan:", join_url( \%url ) );
    printlog( 'dbg', "Starting scan", join_url( \%url ) );
    on_interrupt(
      sub {
        #    $static{'db'}->flush();
        #local $config{'log_dmp'} = 1;
        #printlog('dev', 'on_interrupt update'),
        $static{'db'}->update( $table, undef,
          { %url, 'scan' => int( time() + hconfig( 'on_interrupt', values %url ) - hconfig( 'period', values %url ) ), } )
          if hconfig( 'on_interrupt', values %url );
      }
    );
    $processor{'prot'}{ $url{'prot'} }{'func'}->( join_url( \%url ) );
    on_interrupt();
    ++$work{'scans'};
    $static{'db'}->flush_insert()
      #      $processor{'out'}{'array'}->()
      if hconfig( 'flush_sql_every_res', values %url );
    next if $config{'scanner'}{ $url{'prot'} }{'no_res_stat'};
  #local $config{'log_dmp'} = 1;
  #printlog('dev', 'on_finish update', 'files=',$work{'filec'}->( $stat{'files'} ), 'size=', $work{'sizec'}->( $stat{'size'} ));
    local %_;
    if ( $work{'filec'}->( $stat{'files'} ) ) {
      %_ = (
        %res, %{ $config{'clear_file'} || {} },
        'files' => $work{'filec'}->( $stat{'files'} ),
        'dirs'  => $work{'dirc'}->( $stat{'dirs'} ),
        'size'  => $work{'sizec'}->( $stat{'size'} )
      );
      $_{'time'} = int( time() );
      $_{'scan'} = int( time() ) unless $work{'scan_unfinished'};
      $static{'db'}->update( $config{'sql_tresource'}, undef, \%_ );
    }
    #    %_ = ( %res, 'ip' => ip_to_name( $url{'host'} ), 'scan' => int( time() ) );
    %_ = ( %res, 'ip' => name_to_ip( $url{'host'} ), 'scan' => int( time() ) );
    $_{'time'} = int( time() ) if $work{'filec'}->( $stat{'files'} );
    $static{'db'}->update( $config{'sql_thost'}, undef, \%_ );
    if ( $work{'sizec'}->( $stat{'size'} ) and ( $work{'filec'}->( $stat{'files'} ) or $work{'filec'}->( $stat{'dirs'} ) ) ) {
      %_ = ( %res, 'path' => '', 'desc' => $work{'desc'}{ $url{'host'} }{ $url{'prot'} }, 'scan' => int( time() ) );
      $static{'db'}->update( $config{'sql_tfile'}, undef, \%_ );
      $_{'path'} = '/';
      $static{'db'}->update( $config{'sql_tfile'}, undef, \%_ );
    }
    #    }
  }
};

sub startme {
  my ($start) = @_;
  if ($start) {
    $static{'db'}->flush_insert();
    #    $processor{'out'}{'array'}->();
    my $force = "force=$config{'force'}" if $config{'force'};
    my $com =
"$config{'starter'} $config{'spawn_prefix'} $config{'perl'} $config{'root_path'}crawler.pl $force $start $config{'spawn_postfix'}";
    printlog( 'dbg', "starting with $start:", $com );
    #    printlog( 'dbg', $com );
    system($com);
  }
}
$processor{'urls'} ||= sub {
  my ( $start, @urlproc );
  for (@_) {
    next unless $_;
    if ( !$config{'noscan'} and $config{'spawn'} and /\:\/\// ) { $start .= " $_ "; }
    else                                                        { push( @urlproc, $_ ); }
  }
  startme($start);
  mysleep( $config{'scan_sleep'} );
  $processor{'url'}->(@urlproc) if @urlproc;
};

=c
$processor{'file'}{'sql'}{'func'} ||= sub {
  my $tper = timer();
  for my $datafile ( grep { $_ } @_ ) {
    my $filesize = ( -s ( $datafile or next ) or next );
    printlog(
      'info',
      'Uploading ',
      $datafile,
      " ($filesize bytes) ...", (
        $tper->()
          and $stat{'total_bytes'}
        ? " prognose:" . psmisc::human('time_period', ( $filesize * $tper->() ) / $stat{'total_bytes'} ) . 's'
        : ''
      )
    );
    my $per = timer();
    rename( $datafile, $datafile . '.up' );
    $processor{'out'}{'mysql_file'}->("$datafile.up");
    rename( $datafile . '.up', $datafile . '.ok' );
    $stat{'total_bytes'} += $filesize;
    printlog(
      'time',
      " done per ",
      $per->(),
      " sec ",
      $per->() ? 'at ' . ( $filesize / $per->() ) . ' b/s ' : '',
      "[total $stat{'total_bytes'} bytes per ",
      psmisc::human('time_period', $tper - () ),
      " sec ",
      ( $tper->() ? 'at ' . int( $stat{'total_bytes'} / $tper->() ) : '' ),
      ' b/s]',
    );
  }
};
=cut

#!!! TODO : gz tgz
$processor{'file'}{'bz2'}{'func'} ||= sub {
  my $tper = timer();
  $processor{'file'}{'xml'}{'func'}->(@_), return if $config{'direct_unzip'};
  for my $datafile ( grep { $_ } @_ ) {
    #    my $filesize = -s $datafile;
    my $filesize = ( -s ( $datafile or next ) or next );
    printlog(
      'info',
      'Extracting ',
      $datafile,
      " ($filesize bytes) ...", (
        $tper->() and $stat{'total_bytes'} ? " prognose:" . int( ( $filesize * $tper->() ) / $stat{'total_bytes'} ) . 's' : ''
      )
    );
    my $per = timer();
    shelldata($datafile);
    printprog( "$config{'bzip2'} $config{'bzip2_uncompress'} \"$datafile\"", 1 );
    rename( $datafile, $datafile . '.ok' );
    $stat{'total_bytes'} += $filesize;
    printlog(
      'time',
      " done per ",
      $per->(),
      " sec ",
      $per->() ? 'at ' . ( $filesize / $per->() ) . ' b/s ' : '',
      "[total",
      psmisc::human( 'size', $stat{'total_bytes'} ),
      "bytes per",
      psmisc::human( 'time_period', $tper->() ),
      ' ',
      ( $tper->() ? 'at ' . int( $stat{'total_bytes'} / $tper->() ) : '' ),
      ' b/s]',
    );
  }
};
$processor{'file'}{'xml'}{'func'} ||= sub {    #dc++
  my $tper = timer();
  my ( %url, %files );
  $url{'prot'} = 'dchub';
  for my $datafile ( grep { $_ } @_ ) {
    my $datafilebug = $datafile;
    my $per         = timer();
    #    my $filesize    = -s $datafile;
    my $filesize = ( -s ( $datafile or next ) or next );
    my $scan = int( $^T - ( -M $datafile ) * 86400 );
    #int( time() )
    printlog(
      'dc',
      'Parsing ',
      $datafile,
      " ($filesize bytes) ...", (
        $tper->() and $stat{'total_bytes'} ? " prognose:" . int( ( $filesize * $tper->() ) / $stat{'total_bytes'} ) . 's' : ''
        )
        #   , 'scan=', $scan, ' now=', int(time()), ' mdf=' , ( -M $datafile ) * 86400
    );
    rename( $datafile, $datafile . '.up' );
    on_interrupt( sub { rename( $datafile . '.up', $datafile ); } );
    if (
      open( FXI, (
          $datafile =~ /\.xml\.bz2$/i
          ? "$config{'bzip2'} $config{'bzip2_uncompress'}c \"$datafile.up\"|"
          : '<' . $datafile . '.up'
        )
      )
      )
    {
      my @dir;
      my $path = '/';
      %url = ( %url, 'port' => '', split_url( $work{'current_dchub'} ) );    #clean port of prev iteration
      $url{'dcuser'} = cp_trans( $config{'cp_shell'}, $config{'cp_db'}, decode_url($datafile) );
      $url{'dcuser'} =~ s/\.xml(\.bz2)?$//i;
      $url{'dcuser'} =~ s{^.+(\\|/)}{}i;
      $url{'host'} = full_host( \%url );
      my %time =
        ( hconfig( 'unknown_time', $url{'host'} ) ne ''
        ? ( 'time' => int( time() ) - hconfig( 'unknown_time', $url{'host'} ) )
        : () );
      ( $work{'sizec'}, $work{'filec'}, $work{'dirc'} ) =
        ( counter( $stat{'size'} ), counter( $stat{'files'} ), counter( $stat{'dirs'} ) );
      local $/ = '<';

      while (<FXI>) {
        if ( my ( $file, $size, $tiger ) = /^File Name="([^"]+)" Size="(\d+)" TTH="([^"]+)"/i ) {
          #printlog('dev','1', $config{'cp_dc_list'}, $config{'cp_db'}, $file);
          local $_ = $file = cp_trans( $config{'cp_dc_list'}, $config{'cp_db'}, $file );
          #printlog('dev','2', $config{'cp_dc_list'}, $config{'cp_db'}, $file);
          my ($ext) = ( $file =~ s/\.([^\.]+)$// ? ($1) : ('') );
          $files{ $path . '/' . $_ } = {
            %url,
            'path' => $path,
            'name' => $file,
            'ext'  => $ext,
            'size' => $size,
            %time, (
              $config{'sql'}{'table'}{ $config{'sql_tfile'} }{'tiger'}    #{'array_insert'}
              ? ( 'tiger' => $tiger )
              : ( 'desc' => 'tiger=' . $tiger )
            ),
            'scan' => $scan
          };
        } elsif ( my ($file) = /^Directory Name="([^"]+)">/i ) {    #"
          local $_ = $file = cp_trans( $config{'cp_dc_list'}, $config{'cp_db'}, $file );
          push( @dir, $file );
          my ($ext) = ( $file =~ s/\.([^\.]+)$// ? ($1) : ('') );
          $files{ $path . '/' . $_ } = { %url, 'path' => $path, 'name' => $file, 'ext' => $ext, %time, 'scan' => $scan };
          $path = ( join( '/', @dir ) or '/' );
        } elsif (m|^/Directory>|i) {
          $static{'db'}->insert_hash_hash( $config{'sql_tfile'}, \%files );
          %files = ();
          pop(@dir);
          $path = ( join( '/', @dir ) or '/' );
        } elsif (/^FileListing .*Base="([^"]+)"/i) {                #"mc
          @dir = ( $1 eq '/' ? '' : $1 );
          $path = ( join( '/', @dir ) or '/' );
          $_ = {
            %url, (
              hconfig( 'unknown_time', $url{'host'} ) ne ''
              ? ( 'time' => int( time() ) - hconfig( 'unknown_time', $url{'host'} ) )
              : ()
            ),
            'scan' => $scan
          };
          %_ = ( '' => $_, ' ' => { %$_, 'path' => '/' }, );
          $static{'db'}->insert_hash_hash( $config{'sql_tfile'}, \%_ );
        }
      }
      close(FXI);
      on_interrupt();
      %_ = (
        %url,
        'scan'  => $scan,
        'files' => $work{'filec'}->( $stat{'files'} ),
        'dirs'  => $work{'dirc'}->( $stat{'dirs'} ),
        'size'  => $work{'sizec'}->( $stat{'size'} ),
      );
      $_{'time'} = $scan if $work{'filec'}->( $stat{'files'} );
      $static{'db'}->update( $config{'sql_tresource'}, undef, { %_, %{ $config{'clear_file'} || {} } } );
    }
    rename( $datafilebug . '.up', $datafilebug . '.ok' );
    $stat{'total_bytes'} += $filesize;
    printlog(
      'time',
      " done per ",
      psmisc::human( 'time_period', $per->() ),
      " sec ",
      $per->() ? 'at ' . psmisc::human( 'float', $filesize / $per->() ) . ' b/s ' : '',
      "[total $stat{'total_bytes'} bytes per ",
      psmisc::human( 'time_period', $tper->() ),
      ' ',
      ( $tper->() ? 'at ' . int( $stat{'total_bytes'} / $tper->() ) : '' ),
      ' b/s]',
    );
  }
};
$processor{'file'}{'toscan'}{'func'} ||= sub {
  local $config{'force'} = 1;
  for my $datafile ( grep { $_ } @_ ) {
    my $url = ( $datafile or next );
    $url =~ s{^.+(\\|/)}{}i;
    $url =~ s/\.toscan$//i;
    $url = decode_url($url);
    local $config{'ftp_recurse_force'} = 1;
    resetcounters();
    $processor{'prot'}{'ftp'}{'func'}->($url);
  }
};
for ( keys %{ $processor{'format'} } ) {
  $processor{'file'}{$_}{'func'} ||= sub {
    for my $datafile ( grep { $_ } @_ ) {
      rename( $datafile, $datafile . '.up' );
      open( F, '<', $datafile . '.up' ) or next;
      $datafile =~ s/.$_$//i;
      $processor{'format'}{$_}->( $datafile, \*F );
      close(F);
      rename( $datafile . '.up', $datafile . '.ok' );
    }
  };
}
$processor{'file'}{'url'}{'func'} ||= sub {
  for my $datafile ( grep { $_ } @_ ) {
    #printlog('dev', "LOAD:$datafile");
    open( IF, ( ( $datafile eq '-' ) ? ($datafile) : ( '<', $datafile ) ) ) or next;
    $processor{'url'}->(<IF>);
    close(IF);
  }
};
$processor{'file'}{'config'}{'func'} = $processor{'file'}{'hublist'}{'func'} ||= sub {
  local $config{'host_by_name_norm'} = 0;
  for my $datafile ( grep { $_ } @_ ) {
    next
      unless (
      open( HL, (
            ( $datafile eq '-' )
          ? ($datafile)
          : ( $datafile =~ /\.xml\.bz2$/i ? "$config{'bzip2'} $config{'bzip2_uncompress'}c \"$datafile\"|" : '<' . $datafile )
        )
      )
      );
    printlog( 'dc', 'hublist: loading', $datafile );
    while (<HL>) {
      if (m| Address="\s*([^:/"]+):?(\d*)\s*"|i) {    #"mc
        $processor{'url'}->( 'dchub://' . $1 . ( $2 and $2 != 411 ? ':' . $2 : '' ) );
        ++$stat{'hublist'};
      }
    }
    close(HL);
  }
};
$processor{'file'}{'list'}{'func'} ||= sub {
  local $config{'host_by_name_norm'} = 0;
  for my $datafile ( grep { $_ } @_ ) {
    next unless ( open( HL, ( ( $datafile eq '-' ) ? ($datafile) : ( '<', $datafile ) ) ) );
    printlog( 'dc', 'hub .list: loading', $datafile );
    while (<HL>) {
      if (m{^\s*([^:/\|]+):?(\d*)\s*\|}i) {
        $processor{'url'}->( 'dchub://' . $1 . ( $2 and $2 != 411 ? ':' . $2 : '' ) );
        ++$stat{'list'};
      }
    }
    close(HL);
  }
};
$processor{'file'}{'ok'}{'func'} ||= sub { unlink(@_) unless $config{'keep_ok'} or $config{'debug'}; };
$processor{'file'}{'dchub'}{'func'} ||= sub {
  for my $datadir ( grep { $_ and -d } @_ ) {
    $work{'current_dchub'} = $datadir;
    $work{'current_dchub'}      =~ s{(^.*[/\\])|(\.dchub$)}{}ig;
    $work{'current_dchub'}      =~ s/\.(\d+)$/:$1/
      if $work{'current_dchub'} =~ /(\d+\.){4}(\d+)$/
        or $work{'current_dchub'} =~ /\D\.(\d+)$/;
    printlog( 'dbg', "dir:", $datadir, " hub:$work{'current_dchub'}" );
    local $config{'del_empty_dir'} = $config{'del_empty_dcdir'};
    $processor{'dir'}->($datadir);
  }
  #  $processor{'out'}{'array'}->();
  $static{'db'}->flush_insert();
};
$processor{'file'}{'ldi'}{'func'} ||= sub {
  my $table = $config{'sql_tfile'};
  for my $datafile ( grep { $_ } @_ ) {
    rename( $datafile, $datafile . '.up' );
    my $mydatafile = $datafile;
    $mydatafile =~ s!\\+|/+!$config{'slash_mysql'}!g;
    next if !$mydatafile or !-s $mydatafile . '.up';
    #my ( $tq, $rq, $vq ) = $static{'db'}->quotes();
    $static{'db'}->do(
"LOAD DATA LOW_PRIORITY LOCAL INFILE '$mydatafile.up' REPLACE INTO TABLE $config{'sql_tfile'} FIELDS OPTIONALLY ENCLOSED BY \"'\" ("
        . join(
        ',',
        map( "$rq$_$rq", (
            sort { $config{'sql'}{'table'}{$table}{$b}{'order'} <=> $config{'sql'}{'table'}{$table}{$a}{'order'} }
              grep( $config{'sql'}{'table'}{$table}{$_}{'array_insert'}, keys %{ $config{'sql'}{'table'}{$table} } )
            ) )
        )
        . ")"
    );
    rename( $datafile . '.up', $datafile . '.ok' );
  }
};
$processor{'dir'} ||= sub {
  for my $dir (@_) {
    printlog( 'info', "uploading [$dir]" );
    $dir .= $config{'slash_perl'} if $dir and !( $dir =~ /[\/\\]$/ );
    #printlog( 'dev', "dir: [$dir]:",<$dir*.$_>, <$dir.*.$_> );
    #!!! READDIR HERE
    for ( shuffle( keys %{ $processor{'file'} } ) ) {    #!!!!SORT
      #      $processor{'file'}{$_}{'func'}->( @{ shuffle( [ <$dir*.$_>, <$dir.*.$_> ] ) } )
      $processor{'file'}{$_}{'func'}->( grep { $_ } shuffle( <$dir*.$_>, <$dir.*.$_> ) )
        if $processor{'file'}{$_}{'func'} and !$processor{'file'}{$_}{'disabled'};    #and @dir;
    }
    printlog( 'dbg', "deleted empty $dir:", ( rmdir($dir) or $! ) ) if $config{'del_empty_dir'} and !( <$dir*>, <$dir.*> );
  }
  $static{'db'}->flush_insert();
  #  $processor{'out'}{'array'}->();
};
#{
#my ( $current, $order );
#sub newcurrent { $program{ $current = $_[0] }{'order'} ||= $order += 10; }            #v2
#}
psmisc::program('check');
$program{ psmisc::program() }{'func'} ||= sub {
  printlog( 'info', 'checkset' );
  $config{'sql'}{'auto_repair'}  = 1;
  $config{'sql'}{'force_repair'} = 1;
};
psmisc::program('init');
$program{ psmisc::program() }{'force'} = 1;
$program{ psmisc::program() }{'func'} ||= sub {
  printlog(
    'info', "Started with [",
    $^X, $work{'$0'}, join ' ',
    map( $_ . ( ( $param->{$_} ne '' and $param->{$_} != 1 ) ? "=$param->{$_}" : '' ), sort keys %$param ),
    "] version:", ( $config{'version'} or 'r' . ( split( ' ', '$Revision: 4097 $' ) )[1] )
    )
    if    # $param and
    %$param and !$config{'nolog_startstop'};
  mkdir_rec( $config{'datadir'}, 0777 );
  mkdir_rec( $config{'tmpdir'},  0777 );
  $config{'sql_mysqlopt'} = ( $config{'sql_host'} ? ' -h ' . $config{'sql_host'} : ' ' ) . ' ' . $config{'sql_mysqlopt'} . ' ';
  $static{'banned'} = { loadlist( $config{'file_banned'} ), %{ $config{'banned'} or {} } };
  $config{'sql'}{'database'} = $config{'sql_base_up'};
  $work{'cp_input'} = $config{'cp_shell'};
  psmisc::lib_init();
  $static{'db'} ||= pssql->new(
    'codepage'        => $config{'cp_db'},
    'handler_insert0' => sub {
      my ( $self, $table, $hash ) = @_;
      #printlog('dev', 'handler_insert0', @_);
      if ( $table eq $config{'sql_tfile'} ) {    #TODO CONFIGURABLE

=old
        if (  !$self->{'use_dbi'}
          and $work{'current_output_file'} ne $hash->{$_}{'host'}
          and $hash->{'host'} )
        {
          $work{'current_output_file'} = $hash->{'host'};
          open_out_file( $work{'current_output_file'} );
        }
=cut

        if ( $hash->{'size'} ) {
          ++$stat{'files'};
          $stat{'size'} += $hash->{'size'} if $hash->{'size'} < $config{'max_stat_file_size'};
        } else {
          ++$stat{'dirs'};
        }
      }
    },
    'handler_insert2' => sub {
      my ( $self, $table, $hash ) = @_;
      #printlog('dev', 'handler_insert2', @_);
      $work{'upscanned'} = counter( $stat{'files'} ) unless $work{'upscanned'};
      if (  $work{'filec'}
        and $work{'filec'}->( $stat{'files'} )
        and $work{'upscanned'}->( $stat{'files'} ) > $config{'update_scan_every'} )
      {
        #local $config{'log_dmp'} = 1;
        #printlog('dev', 'on_update update'),
        $work{'upscanned'} = counter( $stat{'files'} );
        #        my ($values) = values(%$hash);
        my ($values) = $hash;
        #printlog('dev', 'handler_insert2values:', $values);
        #        sql_update(
        my %scantime = ( 'scan' => int( time() ), 'time' => int( time() ) ) if $values->{'prot'} ne 'dchub';
        $self->update(
          $config{'sql_tresource'},
          undef, {
            $self->filter_row( $config{'sql_tresource'}, 'primary', $values ),
            'path' => '',
            #            'scan' => int( time() ),
            #           'time' => int( time() )
            %scantime
          }
        );
#!!! TODO < BUG !!!
#printlog('dev', 'now=', 'files=',$work{'filec'}->( $stat{'files'} ), 'size=', $work{'sizec'}->( $stat{'size'} ));
#$self->select_log($config{'sql_tresource'}, {$self->filter_row( $config{'sql_tresource'}, 'primary', $values ), 'path'  => '',});
#printlog('dev', 'wherebody=',$self->where_body({'files' => $work{'filec'}->( $stat{'files'} ), 'files_mode'=>'g'}, undef, $config{'sql_tresource'}, ));
        $self->update(
          #        sql_update(
          $config{'sql_tresource'},
          undef, {
            $self->filter_row( $config{'sql_tresource'}, 'primary', $values ),
            'path'  => '',
            'files' => $work{'filec'}->( $stat{'files'} ),
            'dirs'  => $work{'dirc'}->( $stat{'dirs'} ),
            'size'  => $work{'sizec'}->( $stat{'size'} )
          },
          $self->where_body(
            { 'files' => $work{'filec'}->( $stat{'files'} ), 'files_mode' => 'l' },
            undef, $config{'sql_tresource'},
            )
            #          "$self->{'rq'}files$self->{'rq'} < " . $self->{'vq'} . $work{'filec'}->( $stat{'files'} ) . $self->{'vq'}
        );
        my $h = split_url( $values->{'host'} )->{'host'};
        $self->update(
          #        sql_update(
          $config{'sql_thost'},
          undef, {
            $self->filter_row( $config{'sql_thost'}, 'primary', $values ),
            'host' => $h,
            #            'ip'   => ip_to_name($h),
            ( $values->{'prot'} eq 'dchub' ? () : ( 'ip' => name_to_ip($h) ) ),
            #            'scan' => int( time() ),
            #            'time' => int( time() )
            %scantime
          }
        );
      }
    },
    %{ $config{'sql'} or {} },
  );
  ( $tq, $rq, $vq ) = $static{'db'}->quotes();
#  $processor{'out'}{'array'}->();
#  my ( $tq, $rq, $vq ) = $static{'db'}->quotes();
#  $static{'db'}->query_log( 'SELECT * FROM ' . ( join ',', map { "$tq$_$tq" } sort keys %{ $config{'sql'}{'table'} } ) . ' WHERE 1 LIMIT 1' )
#        use Data::Dumper;
#    printlog( 'dev', Dumper($static{'db'}));
  unless ( keys %$param ) {
    printlog( 'info',
          'Short usage: '
        . ( $work{'$0'} || $0 )
        . ' [install] [file.to.load] [ftp://res.to.scan] [proc[=3]] [--configparam=value] [--sql__configparam=value]' );
  }
  return 0;
};
psmisc::program('drop');
$program{ psmisc::program() }{'func'} ||= sub {
  @_ = keys %{ $config{'sql'}{'table'} } if !@_;
  printlog( 'info', "Dropping ", @_ );
  #  printlog( 'info', "Dropping $static{'db'}->{'table_prefix'} [$_]" ), $processor{'out'}{'mysql'}->( drop_table_sql($_) )
  #    for sort grep { $_ and $config{'sql'}{'table'}{$_} } @_;
  $static{'db'}->drop_tables( sort grep { $_ and $config{'sql'}{'table'}{$_} } @_ );
  return 0;
};
psmisc::program('install');
$program{ psmisc::program() }{'func'} ||= sub {
  my %bases;
  $bases{ $config{$_} } = $_ for grep /^sql_base_/, keys %config;
  $static{'db'}->install( grep $_, keys %bases );

=cu
  my ( $tdbi, $tb ) = ( $config{'sql_use_dbi'}, $config{'sql_base'} );
  $config{'sql_use_dbi'} = 0;
  $config{'sql_base'}    = '';
  for ( grep $_, keys %bases ) {
    printlog( 'info', "Creating database '$_' [$bases{$_}]" );
    $processor{'out'}{'mysql'}->(
      "CREATE DATABASE IF NOT EXISTS $_"
        . (
        $config{'sql_default_character_set'}
          and $config{'sql'}{ $config{'sql_driver'} }{'DEFAULT CHARACTER SET'}
        ? " $config{'sql'}{ $config{'sql_driver'} }{'DEFAULT CHARACTER SET'} $config{'sql_default_character_set'}"
        : ''
        )
    );
  }
  ( $config{'sql_base'}, $config{'sql_use_dbi'} ) = ( $tb, $tdbi );
  printlog( 'info', "Creating $static{'db'}->{'table_prefix'} [", ( keys %{ $config{'sql'}{'table'} } ), ']' );
  $processor{'out'}{'mysql'}->( create_table_sql( %{ $config{'sql'}{'table'} } ) );
  $processor{'out'}{'mysql'}->( create_index_sql( %{ $config{'sql'}{'table'} } ) )
    unless $config{'sql'}{ $config{'sql_driver'} }{'index in create table'};
=cut

  return 0;
};
psmisc::program('index_disable');
$program{ psmisc::program() }{'func'} ||= sub {
  return $static{'db'}->index_disable( $config{'sql_tfile'} );
  #  my $tim = timer();
  #  printlog( 'info', 'Disabling indexes...' );
  #  printlog( 'err', 'ALTER TABLE ... DISABLE KEYS available in mysql >= 4' ), return if $config{'sql'}{'driver'} eq 'mysql3';
  #  $static{'db'}->query_log("ALTER TABLE $static{'db'}->{'table_prefix'}$config{'sql_tfile'} DISABLE KEYS");
  #  printlog( 'time', "Disable index per", psmisc::human( 'time_period', $tim->() ), "sec" );
};
psmisc::program('upgrade');
$program{ psmisc::program() }{'func'} ||= sub {
  local $config{'sql_base'}        = $config{'sql_base_web'};
  local $config{'sql_error_tries'} = 0;
  local $config{'sql_error_sleep'} = 0;
  printlog( 'info', "Upgrade from $_[0]. dont worry about errors" );
  printlog( 'info', 'Removing very old resource.vote,votelast' ),
    $static{'db'}->do("ALTER TABLE resource DROP `vote`, DROP `votelast`, DROP INDEX votei, DROP INDEX votelasti")
    if $_[0] < 1905;
  printlog( 'info', 'Removing host.votelast' ), $static{'db'}->do("ALTER TABLE host DROP `votelast`, DROP INDEX votelasti"),
    printlog( 'info', 'Adding host voting' ),
    $static{'db'}->do(
"ALTER TABLE host ADD `voteu` INT  NOT NULL  DEFAULT 0, ADD `voted` INT  NOT NULL  DEFAULT 0, ADD INDEX voteui (`voteu`), ADD INDEX votedi (`voted`)"
    ), $static{'db'}->do("ALTER TABLE host ADD `lastip` VARCHAR (15) NOT NULL DEFAULT 0, ADD INDEX lastipi (`lastip`(15))"),
    printlog( 'info', 'Adding top query lastip' ),
    $static{'db'}
    ->do("ALTER TABLE $config{'sql_twordstat'} ADD `lastip` VARCHAR (15) NOT NULL DEFAULT 0, ADD INDEX lastipi (`lastip`(15))"),
    $static{'db'}->do(
    "ALTER TABLE $config{'sql_tquerystat'} ADD `lastip` VARCHAR (15)  NOT NULL  DEFAULT 0, ADD INDEX lastipi (`lastip`(15))")
    if $_[0] < 1933;
  printlog( 'info', '{2618} 0.15.18 -> 0.16.0 (adding port column into host table)' ),
    $static{'db'}
    ->do("ALTER TABLE $config{'sql_thost'} ADD `port` SMALLINT UNSIGNED NOT NULL  DEFAULT 0, ADD INDEX porti (`port`)")
    if $_[0] < 2618;
  printlog( 'info', '{2970} 0.16.1 -> 0.16.2 (adding fulltext query index)' ),
    $static{'db'}->do(
"ALTER TABLE $config{'sql_tquerystat'} ADD FULLTEXT $config{'sql'}{'table'}{$config{'sql_tquerystat'}}{'query'}{'fulltext'} (`query`)"
    ) if $_[0] < 2970 and $config{'sql'}{'table'}{ $config{'sql_tquerystat'} }{'query'}{'fulltext'};
  printlog( 'info', '{3010} 0.16.1 -> 0.16.2 (adding dcuser to filebase and resource)' ),
    $static{'db'}
    ->do("ALTER TABLE `$config{'sql_tfile'}` ADD `dcuser` VARCHAR( 30 ) NOT NULL AFTER `host`, ADD INDEX dcuseri (`dcuser`)"),
    $static{'db'}->do(
    "ALTER TABLE `$config{'sql_tresource'}` ADD `dcuser` VARCHAR( 30 ) NOT NULL AFTER `host`, ADD INDEX dcuseri (`dcuser`)"),
    $static{'db'}->do(
"ALTER TABLE `$config{'sql_tfile'}` DROP PRIMARY KEY , ADD PRIMARY KEY ( `prot` , `host` , `path` , `name` , `ext` , `dcuser` )"
    ),
    $static{'db'}
    ->do("ALTER TABLE `$config{'sql_tresource'}` DROP PRIMARY KEY , ADD PRIMARY KEY ( `prot` , `host` , `path` , `dcuser` )"),
    if $config{'use_dc'} and $_[0] < 3010;
  printlog( 'info', '{3120} 0.16.1 -> 0.16.2 (adding voting to filebase)' ),
    $static{'db'}->do(
"ALTER TABLE `$config{'sql_tfile'}` ADD `voteu` INT  UNSIGNED NOT NULL  DEFAULT '0' , ADD `voted` INT  UNSIGNED NOT NULL  DEFAULT '0' , ADD `lastip` VARCHAR (15)  NOT NULL  DEFAULT '' , ADD INDEX voteui (`voteu`), ADD INDEX votedi (`voted`), ADD INDEX lastipi (`lastip`(15))"
    ),
    if $_[0] < 3120;

  if ( $_[0] < 3939 ) {
    printlog( 'info', '{3939} 0.17.2 -> 0.18.0 (adding added to filebase)' ),
      $static{'db'}->do("ALTER TABLE `$config{'sql_tfile'}` ADD `added` INT  UNSIGNED NOT NULL  DEFAULT '0'");
    printlog( 'info', '{3939} 0.17.2 -> 0.18.0 (adding stem to filebase)' ),
      $static{'db'}->do("ALTER TABLE `$config{'sql_tfile'}` ADD `stem` VARCHAR (128)  NOT NULL  DEFAULT ''"),
      printlog( 'info', '{3939} 0.17.2 -> 0.18.0 (adding stem index to filebase)' ),
      $static{'db'}->do("ALTER TABLE `$config{'sql_tfile'}` ADD FULLTEXT `stemi` (`stem`)"),
      printlog( 'info', '{3939} 0.17.2 -> 0.18.0 (adding stem to querystat)' ),
      $static{'db'}->do("ALTER TABLE `$config{'sql_tquerystat'}` ADD `stem` VARCHAR (128)  NOT NULL  DEFAULT ''"),
      printlog( 'info', '{3939} 0.17.2 -> 0.18.0 (adding stem index to querystat)' ),
      $static{'db'}->do("ALTER TABLE `$config{'sql_tquerystat'}` ADD FULLTEXT `stemi` (`stem`)"),
      if $config{'use_stem'};
  }
  #
  $program{$_}{'upgrade'}->(@_) for grep { ref $program{$_}{'upgrade'} eq 'CODE' } keys %program;
  psmisc::program_one('install');
};
$program{ psmisc::program('repair') }{'func'} ||= sub {
  $static{'db'}->repair(@_);

=c
  my $tim = timer();
  @_ = keys %{ $config{'sql'}{'table'} } unless @_;
  @_ = grep { $_ and $config{'sql'}{'table'}{$_} } @_;
  printlog( 'info', 'Repairing table...', @_ );
  psmisc::program_one('flush');
  local $config{'sql_error_tries'} = 0;    #!
  $static{'db'}->query_log( "REPAIR TABLE "
      . join( ',', map( $static{'db'}->tquote("$static{'db'}->{'table_prefix'}$_"), @_ ) )
      . ( $config{'rep_quick'} ? ' ' . $static{'db'}->{'QUICK'}    : '' )
      . ( $config{'rep_ext'}   ? ' ' . $static{'db'}->{'EXTENDED'} : '' )
      . ( $config{'rep_frm'}   ? ' ' . $static{'db'}->{'USE_FRM'}  : '' ) );
  psmisc::program_one('flush');
  printlog( 'time', 'Repair per', psmisc::human( 'time_period', $tim->() ) );
=cut

};
psmisc::program('purge');
$program{ psmisc::program() }{'func'} ||= sub {
  my ($purge) = ( $_[0] =~ /(\d+)/ ? $1 : $config{'purgedef'} );
  my ( $cut, $timr, $total, $now ) = ( int( time() ), timer() );
  printlog( 'info', "Purging tables (by $purge). cut =", psmisc::human( 'date_time', $cut -= $config{'purge_time'} ), $_[2] );
  local $config{'nav_all'} = 1;
  for my $table ( $_[1] or grep { $config{'sql'}{'table_param'}{$_}{'purge'} } keys %{ $config{'sql'}{'table'} } ) {
    #    printlog('dev', 'pg', $config{'sql'}{'table_param'}{$table}{'purge'});
    for my $i ( 1 .. $config{'purges'} ) {
      my $timl = timer();
      $total += (
        $now = $static{'db'}->do(
          "DELETE LOW_PRIORITY FROM $tq$static{'db'}->{'table_prefix'}$table$tq "
            . $static{'db'}->where( {
              $config{'sql'}{'table_param'}{$table}{'purge'} . ''       => 0,
              $config{'sql'}{'table_param'}{$table}{'purge'} . '1'      => $cut,
              $config{'sql'}{'table_param'}{$table}{'purge'} . '_mode1' => '<',
              'glueg1'                                                  => 'or',
            },
            undef, $table
            )
            . " $_[2] LIMIT $purge"
        )
      );
      printlog(
        'info',
        "purge $table pass $i of $config{'purges'}, $now records purged ($total total) per",
        psmisc::human( 'time_period', $timl->() )
      );
      last                              if $now < $purge;
      mysleep( $config{'purge_sleep'} ) if $config{'purge_sleep'};
    }
  }
  printlog(
    'time',
    "Purged $total records per",
    psmisc::human( 'time_period', $timr->() ),
    ' (', ( $timr->() > 0 ? psmisc::human( 'float', $total / $timr->() ) : '?' ),
    ' fps)'
  );
  return $total;
};
psmisc::program('delhost');
$program{ psmisc::program() }{'func'} ||= sub {
  return unless $_[0];
  my ($purge) = ( $config{'purgedef'} );
  my ( $tfiles, $files, $rec );
  my $timr = timer();
  printlog( 'info', "delhost $_[0] (by $purge)." );
  my $purges = ( $param->{'purges'} or 10000 );
  for my $i ( 1 .. $purges ) {
    my $timl = timer();
    $tfiles += (
      $files =
        #        $processor{'out'}{'mysql'}
        $static{'db'}->do(
"DELETE LOW_PRIORITY FROM $tq$static{'db'}->{'table_prefix'}$config{'sql_tfile'}$tq WHERE ${rq}host${rq} LIKE ${vq}$_[0]${vq} LIMIT $purge"
        )
    );
    printlog( 'info', "pass $i/$purges, $files files deleted, (total $tfiles) per", psmisc::human( 'time_period', $timl->() ) );
    mysleep( $config{'purge_sleep'} ) if $config{'purge_sleep'};
    last                              if $files < $purge;
  }
  $tfiles +=
    $static{'db'}->do("DELETE LOW_PRIORITY FROM $tq$static{'db'}->{'table_prefix'}$_$tq WHERE ${rq}host${rq} = ${vq}$_[0]${vq}")
    for ( $config{'sql_thost'}, $config{'sql_tresource'} );
  printlog(
    'time',
    "Deleted $tfiles files and $rec records per",
    psmisc::human( 'time_period', $timr->() ),
    'sec (', psmisc::human( 'float', $timr->() > 0 ? $tfiles / $timr->() : '?' ),
    ' fps)'
  );
};
psmisc::program('deldead');
$program{ psmisc::program() }{'func'} ||= sub {
  my $rec;
  $rec +=
    $static{'db'}->do(
"DELETE LOW_PRIORITY FROM $tq$static{'db'}->{'table_prefix'}$_$tq WHERE ${rq}scan${rq} AND ! ${rq}time${rq} AND ! ${rq}files${rq} AND ! ${rq}dl${rq} AND ! ${rq}added${rq}"
    ) for ( $config{'sql_tresource'} );    #, $config{'sql_thost'}
  $rec +=
    $static{'db'}->do(
"DELETE LOW_PRIORITY FROM $tq$static{'db'}->{'table_prefix'}$_$tq WHERE ! ${rq}files${rq} AND ! ${rq}dl${rq} AND ! ${rq}added${rq} AND ! ${rq}voteu${rq} AND ! ${rq}voted${rq} AND ! ${rq}lastip${rq}"
    )                                      # ${rq}scan${rq} AND ! ${rq}time${rq} AND
    for ( $config{'sql_thost'} );
  printlog( 'info', "Deleted  $rec records" );
};
psmisc::program('reset_dead');
$program{ psmisc::program() }{'func'} ||= sub {
  my $rec;
  $rec +=
    $static{'db'}->do(
"UPDATE $tq$static{'db'}->{'table_prefix'}$_$tq SET ${rq}scan${rq} = ${vq}0${vq}, ${rq}time${rq} = ${vq}0${vq} WHERE ! ${rq}files${rq}"
    ) for ( $config{'sql_tresource'} );    #, $config{'sql_thost'}
  printlog( 'info', "Updated $rec records" );
};
psmisc::program('reset_res');
$program{ psmisc::program() }{'func'} ||= sub {
  local $_;
  printlog(
    'info',
    'reset_res:',
    $_ = $static{'db'}->do(
"UPDATE $tq$static{'db'}->{'table_prefix'}$config{'sql_tresource'}$tq SET ${rq}scan${rq} = ${vq}0${vq}, ${rq}time${rq} = ${vq}0${vq}"
    )
  );
  return $_;
};
psmisc::program('reset_res_bug');
$program{ psmisc::program() }{'func'} ||= sub {
  printlog(
    'info',
    'reset_res:',
    $static{'db'}->do(
"UPDATE $tq$static{'db'}->{'table_prefix'}$config{'sql_tresource'}$tq SET ${rq}scan${rq} = ${vq}0${vq}, ${rq}time${rq} = ${vq}0${vq} WHERE ${rq}scan${rq} > $vq"
        . int( time() )
        . $vq
    )
  );
};
psmisc::program('reset_range');
$program{ psmisc::program() }{'func'} ||= sub {
  printlog(
    'info',
    'reset_range:',
    $static{'db'}->do(
"UPDATE $tq$static{'db'}->{'table_prefix'}$config{'sql_tranges'}$tq SET ${rq}scan${rq} = ${vq}0${vq}, ${rq}time${rq} = ${vq}0${vq}"
    )
  );
};
psmisc::program('reset_range_bug');
$program{ psmisc::program() }{'func'} ||= sub {
  printlog(
    'info',
    'reset_range:',
    $static{'db'}->do(
"UPDATE $tq$static{'db'}->{'table_prefix'}$config{'sql_tranges'}$tq SET ${rq}scan${rq} = ${vq}0${vq}, ${rq}time${rq} = ${vq}0${vq} WHERE ${rq}scan${rq} > $vq"
        . int( time() )
        . $vq
    )
  );
};
psmisc::program('reset_period');
$program{ psmisc::program() }{'func'} ||= sub {
  my $rec;
  $rec += $static{'db'}->do("UPDATE $tq$static{'db'}->{'table_prefix'}$_$tq SET ${rq}period${rq} = ${vq}0${vq} ")
    for ( $config{'sql_tresource'}, $config{'sql_tranges'} );    #, $config{'sql_thost'}
  printlog( 'info', "Updated $rec records" );
};
psmisc::program('skip');
$program{ psmisc::program() }{'func'} ||= sub { $static{'banned'}->{ $_[0] } = 1; };
psmisc::program('file');
$program{ psmisc::program() }{'func'} ||= sub {
  printlog( 'info', 'loading file', $_[0] );
  $processor{'file'}{'url'}{'func'}->( uni_get( $_[0] ) );
};
psmisc::program('ipdig');
$program{ psmisc::program() }{'func'} ||= sub {
  my %dig;
  for my $file (@_) {
    printlog( 'info', 'founding ips in', $file );
    open( IF, ( ( $file eq '-' ) ? ($file) : ( '<', uni_get($file) ) ) ) or printlog( 'err', 'unable to open' ), return;
    while (<IF>) {
      for my $name (m!(?:\W|^)($config{'dig_find_mask'})\W!g) {
        next unless $name;
        next if grep { $name =~ /$_$/ } @{ $config{'dig_not_domain'} };
        my ( $ip, $err, $add );
        my %url = split_url($name);
        ( $ip, $err ) = name_to_ip( $url{'host'} );
        printlog( 'dbg', ' NOT ip', $name, $url{'host'}, $ip ), next if $err;
        printlog( 'dbg', ' ip not in mask:', $ip ), next if $ip !~ /$config{'dig_ip_mask'}/;
        unless ( $config{'dig_no_prot'} and !$url{'prot'} ) {
          next if !defined( $config{'scanner'}{ $url{'prot'} } );
          next if $config{'scanner'}{ $url{'prot'} }{'no_dig'};
        }
        $add = join_url( {
            %url,
            ( $config{'dig_as_ip'} ? ( 'host' => $ip ) : () ),
            ( ( $url{'prot'} eq $static{'port2prot'}{ $url{'port'} } ) ? ( 'port' => '' ) : () ),
            ( ( $config{'dig_prot_add'} and !$url{'prot'} ) ? ( 'prot' => $config{'dig_prot_add'} ) : () ),
            ( $config{'host_by_name_norm'} ? ( 'host' => normalize_ip( $url{'host'} ) ) : () ),
            ( ( $url{'user'} =~ /anonymous|ftp|none/i ) ? ( 'user' => '', 'pass' => '' ) : () ),
            ( ( $url{'pass'} =~ /none/i ) ? ( 'pass' => '' ) : () ),
          }
        ) unless $config{'dig_add_netmask'};
        $add = $ip, $add =~ s/\d+$//, $add = $add . '0/' . $config{'dig_add_netmask'} if $config{'dig_add_netmask'};
        printlog( 'dbg', ' digged', $name, '=', $ip, '->', $add ) if !$dig{$add};
        $processor{'url'}->($add) if ( $config{'dig_add_every'} and !$dig{$add} );
        ++$dig{$add};
      }
    }
    close(IF);
  }
  $processor{'url'}->( keys %dig ) unless $config{'dig_add_every'};
  printlog( 'info', ' founded', scalar keys %dig, sort keys %dig );
};
psmisc::program('ipdigf');
$program{ psmisc::program() }{'func'} ||= sub {
  for my $file (@_) {
    printlog( 'info', 'founding ips hrefs in', $file );
    open( IFF, ( ( $file eq '-' ) ? ($file) : ( '<', uni_get($file) ) ) ) or printlog( 'err', 'unable to open' ), return;
    while (<IFF>) {
      next if /^\s*[#;]/;
      s/^\s+//;
      s/\s+$//;
      psmisc::program_one( 'ipdig', $_ ) if $_;
    }
    close(IFF);
  }
};
psmisc::program('hublist');
$program{ psmisc::program() }{'func'} ||= sub {
  $_ = ( $_[0] or $config{'hublist'} );
  $processor{'file'}{ /\.(?:list)|(?:config)$/i ? 'list' : 'hublist' }{'func'}->( uni_get($_) );
};
psmisc::program('default');
$program{ psmisc::program() }{'mask'}       ||= '\S';
$program{ psmisc::program() }{'multi'}      ||= 1;
$program{ psmisc::program() }{'param_name'} ||= 1;
$program{ psmisc::program() }{'func'}       ||= sub {
  for my $current ( keys %program ) {
    next if $current eq 'default';
    return if $program{ psmisc::program() }{'mask'} and $_[0] =~ /$program{psmisc::program()}{'mask'}/i;
  }
  psmisc::program_one( ( -s $_ ? 'file' : 'scan' ), $_ ) for @_;
  #  $processor{'url'}->(@_);
};
psmisc::program('scan');
$program{ psmisc::program() }{'func'} ||= sub {
  #  printlog('dev', 'scan', @_);
  $processor{'url'}->(@_);
};
psmisc::program('upload');
$program{ psmisc::program() }{'func'} ||= sub {
  close_out_file();
  startn( $_[0], 'upload' );
  $processor{'dir'}->( $config{'datadir'} );
};
psmisc::program('index_enable');
$program{ psmisc::program() }{'func'} ||= sub {
  return $static{'db'}->index_enable( $config{'sql_tfile'} );
  #  my $tim = timer();
  #  printlog( 'info', 'Enabling indexes...' );
  #  $static{'db'}->query_log("ALTER TABLE $static{'db'}->{'table_prefix'}$config{'sql_tfile'} ENABLE KEYS");
  #  printlog( 'time', 'Enable index per ', psmisc::human( 'time_period', $tim->() ) );
};
psmisc::program('optimize');
$program{ psmisc::program() }{'func'} ||= sub {
  return $static{'db'}->optimize(@_);
  #  @_ = keys %{ $config{'sql'}{'table'} } unless @_;
  #  @_ = grep { $_ and $config{'sql'}{'table'}{$_} } @_;
  #  printlog( 'info', 'Optimizing table...', @_ );
  #  $static{'db'}->query_log( "OPTIMIZE TABLE " . join( ',', map( "$static{'db'}->{'table_prefix'}$_", @_ ) ) );
};
psmisc::program('analyze');
$program{ psmisc::program() }{'func'} ||= sub {
  return $static{'db'}->analyze(@_);
  #  @_ = keys %{ $config{'sql'}{'table'} } unless @_;
  #  @_ = grep { $_ and $config{'sql'}{'table'}{$_} } @_;
  #  printlog( 'info', 'Analyze table...', @_ );
  #  $static{'db'}->query_log( "ANALYZE TABLE " . join( ',', map( "$static{'db'}->{'table_prefix'}$_", @_ ) ) );
};
psmisc::program('flush');
$program{ psmisc::program() }{'func'} ||= sub {
  #  printlog( 'dev', 'Flush');
  return $static{'db'}->flush(@_);
  #  my $tim = timer();
  #  my ( $tq, $rq, $vq ) = $static{'db'}->quotes();
  #  $static{'db'}->do( "FLUSH TABLES " . ( join ',', map { "$tq$_$tq" } sort keys %{ $config{'sql'}{'table'} } ) );
  #  printlog( 'time', 'Flush per', psmisc::human( 'time_period', $tim->() ) );
  #  0;
};
psmisc::program('prof');
$program{ psmisc::program() }{'func'} ||= sub {
  my $tim = timer();
  #my ( $tq, $rq, $vq ) = $static{'db'}->quotes();
  @_ = grep { $_ ne $config{'sql_tfile'} } keys %{ $config{'sql'}{'table'} } unless @_;
  @_ = grep { $_ and $config{'sql'}{'table'}{$_} } @_;
  psmisc::program( $_, @_ ) for qw(repair optimize);
  printlog( 'time', 'Prof per', psmisc::human( 'time_period', $tim->() ) );
  return 0;
};
psmisc::program('res');
$program{ psmisc::program() }{'proc'} ||= 100;
$program{ psmisc::program() }{'func'} ||= sub {
  #my ( $tq, $rq, $vq ) = $static{'db'}->quotes();
  my ( $join, $what, $where, $lock ) = (
    "LEFT JOIN $tq$static{'db'}->{'table_prefix'}$config{'sql_thost'}$tq USING (${rq}host$rq)",
    ", $tq$static{'db'}->{'table_prefix'}$config{'sql_thost'}$tq.${rq}time$rq AS ${rq}live$rq",
" $tq$static{'db'}->{'table_prefix'}$config{'sql_thost'}$tq.${rq}time$rq IS NULL OR $tq$static{'db'}->{'table_prefix'}$config{'sql_thost'}$tq.${rq}time$rq = ${vq}0$vq OR $tq$static{'db'}->{'table_prefix'}$config{'sql_thost'}$tq.${rq}time$rq > $vq"
      . ( int( time() ) + $config{'timediff'} - $config{'online_minutes'} * 60 )
      . $vq,
    ", $tq$static{'db'}->{'table_prefix'}$config{'sql_thost'}$tq WRITE"
  ) if $config{'scan_online_res'} and !$config{'scan_dead'};
##### TODO !!!!!!!!!!!!! sql_where !!!!!!!!!!!
  #printlog( 'dev', 'PRELOCK' );
  my $protos = join( ' OR ',
    map { " $tq$static{'db'}->{'table_prefix'}$config{'sql_tresource'}$tq.${rq}prot$rq = $vq$_$vq" }
      grep { $config{'scanner'}{$_}{'scanable'} and !$config{'scanner'}{$_}{'disabled'} } keys %{ $config{'scanner'} } )
    or return $config{'nothing_scan_sleep'};
  $static{'db'}->lock_tables("$tq$static{'db'}->{'table_prefix'}$config{'sql_tresource'}$tq WRITE $lock");
  local @_ = ( (
      $config{'scan_dead'} ? ()
      : " NOT $tq$static{'db'}->{'table_prefix'}$config{'sql_tresource'}$tq.${rq}time$rq OR $tq$static{'db'}->{'table_prefix'}$config{'sql_tresource'}$tq.${rq}size$rq > ${vq}0$vq "
    ), (
      $config{'scanner'}{'dchub'}{'disabled'} ? ()
      : ( !%{ $config{'sql'}{'table'}{ $config{'sql_tresource'} }{'dcuser'} or {} }
        ? " $tq$static{'db'}->{'table_prefix'}$config{'sql_tresource'}$tq.${rq}host$rq NOT LIKE $vq%/%$vq "
        : " $tq$static{'db'}->{'table_prefix'}$config{'sql_tresource'}$tq.${rq}dcuser$rq = $vq$vq " )
    ),
    $protos,
    ( $where or () )
  );
  local $_ = grep( $_, @_ ) ? ' WHERE ( ' . join( ') AND (', grep( $_, @_ ) ) . ' ) ' : '';
  my $res =
    $static{'db'}->line(
"SELECT $tq$static{'db'}->{'table_prefix'}$config{'sql_tresource'}$tq.*$what FROM $tq$static{'db'}->{'table_prefix'}$config{'sql_tresource'}$tq $join $_ ORDER BY ($tq$static{'db'}->{'table_prefix'}$config{'sql_tresource'}$tq.${rq}scan$rq"
      . ( $config{'res_fast'} ? '' : "+$tq$static{'db'}->{'table_prefix'}$config{'sql_tresource'}$tq.${rq}period$rq" )
      . ") LIMIT 1" );
#printlog('dev', 'res selectedp:', ($res), );
#printlog('dev', 'res selectedp:', join_url($res), %$res);
#printlog('dev', 'res selected:',( join_url($res), psmisc::human('date_time',$res->{'scan'}),'p=', $res->{'period'},'=', psmisc::human('time_period',$res->{'period'})));
  my %origres = %$res;
  $res->{'period'} ||= hconfig( 'period', $res->{'host'}, $res->{'prot'} );
  printlog(
    'dev',
    'res selected:', (
      join_url($res), psmisc::human( 'date_time',   $res->{'scan'} ),
      'p=',           $res->{'period'},
      '=',            psmisc::human( 'time_period', $res->{'period'} )
    )
  );
  $_ = ( %origres and allowscan( $res, $config{'sql_tresource'}, $res->{'scan'} + 1, $res->{'period'} ) );
#  $_ = ( $static{'db'}->filter_row( $config{'sql_tresource'}, 'primary', $res ) and allowscan( $res, $config{'sql_tresource'}, $res->{'scan'} + 1, $res->{'period'} ) );
#  $_ = ( @{$res}{$static{'db'}->filter_row( $config{'sql_tresource'}, 'primary', $res )} and allowscan( $res, $config{'sql_tresource'}, $res->{'scan'} + 1, $res->{'period'} ) );
#  my $period = ($res->{'period'} or hconfig( 'period', $res->{'host'}, $res->{'prot'} ));
#  $_ = ( %$res and allowscan( $res, $config{'sql_tresource'}, $res->{'scan'} + 1, $period ) );
  $static{'db'}->unlock_tables();
#  printlog( 'dev', "resrun[$_]", %$res, 'fr:',   @{$res}{ $static{'db'}->filter_row( $config{'sql_tresource'}, 'primary', $res ) } );
  if ($_) {
    local $work{'scan_proto_host_reset_force'} = 1 unless $config{'force'};
    local $config{'force'} = 1;
    $processor{'url'}->( join_url($res) );
    return 0;
  } elsif (%$res) {
    my $wait = $res->{'period'} - ( $res->{'scan'} ? int( time() ) - $res->{'scan'} : 0 );
    my $nextscan = ( $_ = $res->{'period'} + $res->{'scan'} - int( time() ) ) > 0 ? $_ : $config{'nothing_scan_sleep'};
    $_ = min( max( $nextscan, 0 ), $config{'nothing_scan_sleep'}, max( $wait, 0 ) + 1 );
    printlog(
      'dbg', 'Res: nothing to do (next:',
      join_url($res), ':', psmisc::human( 'time_period', $nextscan ),
      ') sl(', $_, ')'
    );
    return $_;
  } else {
    printlog( 'dbg', 'all resources is scanned or dead or table is empty?' );
    return $config{'nothing_scan_sleep'};
  }
};
psmisc::program('dcbot');
$program{ psmisc::program() }{'proc'} ||= 1;
$program{ psmisc::program() }{'func'} ||= sub {
  return $config{'nothing_scan_sleep'} if $config{'scanner'}{'dchub'}{'disabled'};
  local $config{'scan_online_res'}              = 0;
  local $config{'scan_dead'}                    = 1;
  local $config{'host_by_name_norm'}            = 0;
  local $config{'scanner'}{'dchub'}{'scanable'} = 1;
  local $config{'scanner'}{'ftp'}{'disabled'}   = 1;
  local $config{'scanner'}{'http'}{'disabled'}  = 1;
  local $config{'scanner'}{'file'}{'disabled'}  = 1;
  local $config{'scanner'}{'rsync'}{'disabled'} = 1;
  return psmisc::program_one('res');
};
psmisc::program('range');
$program{ psmisc::program() }{'proc'} ||= 1;
$program{ psmisc::program() }{'func'} ||= sub {
  #my ( $tq, $rq, $vq ) = $static{'db'}->quotes();
  my $where = $static{'db'}->where( {
      'scan'      => int( time() ),
      'scan_mode' => '<',
      'glueg'     => 'or',
      ( $config{'scan_dead'} ? ( 'time1' => 0, 'alive1' => 1, 'alive_mode1' => '>', 'gluel1' => 'or' ) : () )
    },
    undef,
    $config{'sql_tranges'}
  );
  $static{'db'}->lock_tables("$tq$static{'db'}->{'table_prefix'}$config{'sql_tranges'}$tq WRITE");
  # TODO MAKE QUERY HERE:
  my ( $rng, $tim, $period ) = @{
    $static{'db'}->line(
"SELECT ${rq}range$rq, ${rq}scan$rq, ${rq}period$rq FROM $tq$static{'db'}->{'table_prefix'}$config{'sql_tranges'}$tq $where ORDER BY (${rq}scan$rq+${rq}period$rq) LIMIT 1"
    )
    }{ ( 'range', 'scan', 'period' ) };
  #printlog('dev', 'range selected:',( $rng, psmisc::human('time_period',time-$tim), $period ));
  $static{'db'}->unlock_tables(), return $config{'nothing_scan_sleep'} unless $rng;
  #  $period ||= hconfig( 'range_period', $rng );
  $period ||= hconfig( 'period', $rng, 'range' );
  local $config{'scan_timeout'} = $config{'scan_range_timeout'};
  $_ = allowscan( { 'range' => $rng }, $config{'sql_tranges'}, $tim + 1, $period );
  #printlog('dbg', 'range allowscan:', $_);
  $static{'db'}->unlock_tables();
  if ($_) {
    local $config{'force'} = 1;
    $config{'nmap_only'} = 1 unless defined $config{'nmap_only'};
    $processor{'url'}->($rng);
    return 0;
  } else {
    $period ||= hconfig( 'period', $rng );
    my $nextscan = $period + $tim - int( time() );
    $_ = min( max( $nextscan, 0 ), $config{'nothing_scan_sleep'}, $config{'nothing_scan_sleep'}, max( $period, 0 ) + 1 );
    printlog(
      'dbg', 'range: nothing to do, sleeping ',
      $_, 'seconds (next:',
      $rng, ':', psmisc::human( 'time_period', $nextscan ),
      'period:', psmisc::human( 'time_period', $period ),
      'last:', psmisc::human( 'time_period',   int( time() ) - $tim ), ')'
    );
    return $_;
  }
};

sub startn {
  my ( $how, $from ) = (@_);
  #printlog('dev', 'startn', @_) ;
  #  my $proc = $_[0];
  #    printlog('dev', "start1 proc=$how", @ARGV);
  s/\s*($from)=\d+\s*/$1/i for @ARGV;
  #    printlog('dev', "start2 proc=$how", @ARGV);
  #    printlog('dev', "proc=$how;", join( ' ', grep { /^(-|$from)/ } @ARGV )),
  startme( join( ' ', grep { /^(-|$from)/ } @ARGV ) ) while --$how > 0;
}
psmisc::program('proc');
$program{ psmisc::program() }{'func'} ||= sub {
  #  return unless $config{'sql_use_dbi'};
  startn( $_[0], 'proc' );
  my $min_sleep;
  #printlog( 'dmp', "gggg" );
  while ( !$config{'periodic_stop'} ) {
    my ( $runned, $sleep ) = ( 0, $config{'nothing_scan_sleep'} );
    for my $prog ( sort { $program{$a}{'order'} <=> $program{$b}{'order'} }
      grep { $program{$_}{'proc'} and !$config{ 'noscan_' . $_ } } keys %program )
    {
      ++$runned;
      $work{'proc_scans'} = $program{$prog}{'proc'};
      do {
        state("proc: $prog");
        #printlog( 'dev', "proc $prog run" );
        $_ = alarmed( ( $program{$prog}{'alarm'} or $config{'max_proc_time'} ), $program{$prog}{'func'} );
        printlog( 'proc', "prog $prog returned $_;", $work{'proc_scans'} );
        printlog( 'info', "starting child and exit.." ), startme( join( ' ', grep { /^(-|proc)/ } @ARGV ) ), exit
          if ( $config{'reload_time'} and $work{'start_timer'}->() > $config{'reload_time'} )
          or ( $config{'reload_every'} and $work{'scans'} >= $config{'reload_every'} );
      } while --$work{'proc_scans'} > 0 and !$_;
      $sleep = min( $sleep, max( $_, 0 ) );
      $min_sleep = 0 unless $_;
      #    printlog( 'dbg', "sleep=$sleep, r=$_" );
    }
    printlog( 'info', 'proc: nothing to do, exit' ), last
      if !$runned
        or ( $config{'once'} and $sleep == $config{'nothing_scan_sleep'} );
    $sleep = min( $sleep, ( $min_sleep *= 2 ) ||= 5 );
    $min_sleep = min( $min_sleep, $config{'nothing_scan_sleep'} );
    state( "proc: sleep:", $sleep + $config{'scan_sleep'} );
    printlog( 'dbg', 'sleep..', $sleep, ' + ', $config{'scan_sleep'}, " minsleep=$min_sleep" );
    mysleep( $sleep + $config{'scan_sleep'} );
  }
};
psmisc::program('stat');
$program{ psmisc::program() }{'func'} ||= sub {
  my $qq;
  my ( $tq, $rq, $vq ) = $static{'db'}->quotes();
  for ( 0 .. $_[0] ) {
    mysleep( $config{'stat_sleep'} or 1 ) if $_;
    unless ( $config{'stat_no_res'} ) {
      $qq = "WHERE ${rq}scan${rq} < $vq" . ( int( time() ) - $config{'period'} ) . "$vq ";
      $qq .= " AND ( ${rq}time${rq}=${vq}0${vq} OR ${rq}size${rq}>${vq}0${vq} ) " unless $config{'scan_dead'};
      printlog(
        'info',
        "Resources: to scan ",
        values %{ $static{'db'}->line("SELECT COUNT(*) FROM $tq$static{'db'}->{'table_prefix'}$config{'sql_tresource'}$tq $qq ")
          },
        'from',
        values %{ $static{'db'}->line("SELECT COUNT(*) FROM $tq$static{'db'}->{'table_prefix'}$config{'sql_tresource'}$tq ") }
      );
    }
    unless ( $config{'stat_no_range'} ) {
      #      $qq = 'WHERE ${rq}scan${rq} < \'' . ( int( time() ) - $config{'range_period'} ) . "' ";
      $qq = "WHERE ${rq}scan${rq} < $vq" . ( int( time() ) - hconfig( 'period', 'range' ) ) . "$vq ";
      $qq .= " AND ( ${rq}time${rq}=${vq}0${vq} OR ${rq}alive${rq}>${vq}0${vq} ) " unless $config{'scan_dead'};
      printlog(
        'info',
        'ranges: to scan ',
        values %{ $static{'db'}->line("SELECT COUNT(*) FROM $tq$static{'db'}->{'table_prefix'}$config{'sql_tranges'}$tq $qq ")
          },
        'from',
        values %{ $static{'db'}->line("SELECT COUNT(*) FROM $tq$static{'db'}->{'table_prefix'}$config{'sql_tranges'}$tq ") }
      );
    }
    unless ( $config{'stat_no_total'} ) {
      printlog( 'info', 'totals:',
        map { ( $_, '=', values %{ $static{'db'}->line("SELECT COUNT(*) FROM $tq$static{'db'}->{'table_prefix'}$_$tq ") } ) }
          keys %{ $config{'sql'}{'table'} } );
    }
  }
};
psmisc::program('mrtg');
$program{ psmisc::program() }{'func'} ||= sub {
  my ( $first, $second );

=c
  local $config{'allow_auto_repair'}   = 0;
  local $config{'sql_reconnect_tries'} = 0;
  local $config{'sql_reconnect_sleep'} = 0;
  local $config{'sql_error_tries'}     = 0;
  local $config{'sql_error_sleep'}     = 0;
=cut

  $static{'db'}->retry_off();
  if ( $_[0] eq 'online' ) {
    ( $first, $second ) = @{
      $static{'db'}->line(
"SELECT SUM($static{'db'}->{'table_prefix'}$config{'sql_tresource'}.files) AS files, SUM($static{'db'}->{'table_prefix'}$config{'sql_tresource'}.size) AS size FROM $tq$static{'db'}->{'table_prefix'}$config{'sql_tresource'}$tq LEFT JOIN $tq$static{'db'}->{'table_prefix'}$config{'sql_thost'}$tq USING (host) WHERE $static{'db'}->{'table_prefix'}$config{'sql_tresource'}.files > ${vq}0${vq} AND $static{'db'}->{'table_prefix'}$config{'sql_thost'}.time > '"
          . ( int( time() ) + $config{'timediff'} - $config{'online_minutes'} * 60 ) . "'"
      )
      }{ ( 'files', 'size' ) };
    $first  /= $config{'mrtg_online_files'}, $first  = int($first)  if $config{'mrtg_online_files'};
    $second /= $config{'mrtg_online_bytes'}, $second = int($second) if $config{'mrtg_online_bytes'};
  } else {
    ($first) = @{
      $static{'db'}->line(
"SELECT count(*) as shared FROM $tq$static{'db'}->{'table_prefix'}$config{'sql_tresource'}$tq LEFT JOIN $tq$static{'db'}->{'table_prefix'}$config{'sql_thost'}$tq USING (host) WHERE $static{'db'}->{'table_prefix'}$config{'sql_tresource'}.files > ${vq}0${vq} AND $static{'db'}->{'table_prefix'}$config{'sql_thost'}.time > '"
          . ( int( time() ) + $config{'timediff'} - $config{'online_minutes'} * 60 ) . "'"
      )
      }{ ('shared') };
    ($second) = @{
      $static{'db'}->line(
            "SELECT count(*) as now   FROM $tq$static{'db'}->{'table_prefix'}$config{'sql_thost'}$tq WHERE ${rq}time${rq}>$vq"
          . ( int( time() ) - $config{'online_minutes'} * 60 )
          . $vq
      )
      }{ ('now') };
  }
  if ( $config{'mrtg_out'} and open( MF, '>', $config{'mrtg_out'} ) ) {
    print MF"$first\n$second\nz\nz\n";
    close(MF);
  } else {
    print "$first\n$second\nz\nz\n";
  }
  $static{'db'}->retry_on();
  return 0;
};
psmisc::program('cycle');
$program{ psmisc::program() }{'func'} ||= sub {
  if ( $config{'periodic_func'} ) {
    while ( !$config{'periodic_stop'} ) {
      my $tim = timer();
      $config{'periodic_func'}->() if $config{'periodic_func'};
      printlog(
        'time', "Cycle done per",
        $tim->(),
        "sec; Sleeping $config{'periodic_time'} seconds to ",
        psmisc::human( 'date_time', int( time() ) + $config{'periodic_time'} )
      );
      last if $config{'cycle_once'};
      mysleep( $config{'periodic_time'} );
    }
  }
};
psmisc::program('mystatus');
$program{ psmisc::program() }{'func'} ||= sub {
  $static{'db'}->query_log('SHOW FULL PROCESSLIST');

=c
  if ( $config{'my_dump_file'} and open( FM, '>>', $config{'my_dump_file'} ) ) {
    local $config{'sql_use_dbi'} = 0;
    print FM $static{'db'}->query('SHOW FULL PROCESSLIST');
    close(FM);
  }
=cut

};

=for SIG tests
  psmisc::program('dummy');
  $program{psmisc::program()}{'func'} ||= sub {
    $_[0] = 10 if $_[0] eq 'dummy';
    printlog('info', 'dummy', $_), sleep(1) for 0..$_[0];
  };
=cut

#unless ( $config{'module_crawler'} ) {
psmisc::program_run($param) unless (caller);

sub make_stat {
  return (
    ( defined $work{'start_timer'} ? ( '[run time', psmisc::human( 'time_period', $work{'start_timer'}->() ), ']', ) : () ),
    (
      $stat{'total_bytes'}
      ? " [total $stat{'total_bytes'} bytes per "
        . psmisc::human( 'time_period', $work{'start_timer'}->() ) . ' '
        . ( $work{'start_timer'}->() ? 'at ' . int( $stat{'total_bytes'} / $work{'start_timer'}->() ) : '' ) . ' b/s]'
      : ''
    ), (
      $stat{'files'}
      ? "$stat{'files'} files $stat{'dirs'} dirs scanned."
        . ( $stat{'skipped'} ? " ($stat{'skipped'} skipped)" : '' )
        . (
        $work{'start_timer'}->() ? '(' . psmisc::human( 'float', $stat{'files'} / $work{'start_timer'}->() ) . ' fps)' : '' )
      : ''
    ),
    ( int( $stat{'ftp_reconnects'} ) > 1 ? " with $stat{'ftp_reconnects'} recon." : '' ),
    ( %stat ? ( 'Stat: ', map { "$_=$stat{$_};" } keys %stat ) : () ),
    ,
    ( ref $static{'db'} ? ( '[', $static{'db'}->stat_string(), ']' ) : () ),
  );
}

sub END {
  close_out_file();
  printlog( 'info', 'Finished [', join ' ', map( { $_ . ( $param->{$_} ne '' ? "=$param->{$_}" : '' ) } keys %$param ),
    '] ', make_stat() )
    if $param
      and %$param
      and !$config{'nolog_startstop'};
  #$static{'db'}->log_stat();
}
#   print "\n\n param:\n";for (sort keys %$param) { print "$_ = $param->{$_}\n"; } # debug #
#   print "\n\n config:\n";for (sort keys %config) { print "$_ = $config{$_}\n"; } # debug #
#   print "\n\n config:\n", Dumper(\%config); # debug #
#$static{'db'}->query('error');
#$static{'db'}->do('error');
1;
